﻿#include "FibHeap.h"


Ele::Ele(){}
Ele::Ele(double d){this->d = d;}

FibHeap::FibHeap(){
    m = NULL;
    n = 0;
}
FibHeap::~FibHeap(){
    if(m != NULL){
        Ele* k;
        Ele dummy;
        m->l->r = &dummy;
        while(m != &dummy && m != NULL){
            if(m->next != NULL){
                /*einfuegen der Kinder in die Wurzelliste*/
                k = m->next;
                k->l->r = m->r;
                m->r->l = k->l;
                k->l = m;
                m->r = k;

                /*loeschen des WurzElelements*/
                k = m;
                m = m->r;
                delete k->data;
                delete k;
            }
            else{
                k = m;
                m = m->r;
                delete k->data;
                delete k;
            }
        }
        m = NULL;
    }
}
void* FibHeap::getmin(){
    return m->data;
}
void* FibHeap::ins(float d, void* data){
    Ele* e = new Ele(d);
    e->m = 0;
    e->next = NULL;
    e->data = data;

    /*Einbinden in Wurzelliste*/
    if(m != NULL){
        e->l = m->l;
        e->r = m;
        m->l = e;
        e->l->r = e;
        if(m->d > d)
            m = e;
    }
    else{
        e->l = e;
        e->r = e;
        m = e;
    }

    n++;
    return e->data;
}
void* FibHeap::extmin(){
    if(m != NULL){
        void* result = m->data;
        /*alle Kinder in die Wurzelliste einfuegen*/
        Ele* k = m->next, *b;
        if(k != NULL)
            k->l->r = NULL;				//Listen aufbrechen
        while(k != NULL){
            k->l = m->l;
            b = k->r;					//naechstes Kind abfangen
            k->r = m;
            m->l = k;
            k->l->r = k;
            k = b;
        }
        /*altes min-Elemente ausklinken*/
        m->l->r = m->r;
        m->r->l = m->l;
        b = m->r;
        if(b != m){
            /*falls noch Elemente im fibunacci-Heap vorhanden sind*/
            delete m;
            m = b;

            /*Liste aufraeumen, neues MinimalElement suchen*/
            n--;
            clean();
            return result;
        }
        else{
            delete m;
            m = NULL;
            n = 0;
            return result;
        }

    }
    else
        return NULL;
}
double FibHeap::Extmin(){
    if(m != NULL){
        /*alle Kinder in die Wurzelliste einfuegen*/
        Ele* k = m->next, *b;
        if(k != NULL)
            k->l->r = NULL;				//Listen aufbrechen
        while(k != NULL){
            k->l = m->l;
            b = k->r;					//naechstes Kind abfangen
            k->r = m;
            m->l = k;
            k->l->r = k;
            k = b;
        }
        /*altes min-Elemente ausklinken*/
        m->l->r = m->r;
        m->r->l = m->l;
        b = m->r;
        if(b != m){
            /*falls noch Elemente im fibunacci-Heap vorhanden sind*/
            delete m;
            m = b;

            /*Liste aufraeumen, neues MinimalElement suchen*/
            n--;
            clean();
            return m->d;
        }
        else{
            delete m;
            m = NULL;
            n = 0;
            return m->d;
        }

    }
    else
        return NULL;
}
void FibHeap::clean(){
    if(n > 1){
        /*Hilfsarray a[] anlegen, in das Unterbäume ihrem Grade/Markierung nach
        eingeordnet werden*/
        long int N = (long int) ceil(2*log((double)n));
        Ele** a = new Ele*[N];
        for(long int i = 0; i < N; i++)
            a[i] = NULL;
        /*Alle WurzElemente in a[] einordnen*/
        Ele* k = m;
        k->l->r = NULL;
        while(k != NULL){
            if(a[k->m] == NULL){
                /*Falls das Array an der Stelle k->m frei ist*/
                a[k->m] = k;
                k = k->r;
            }
            else{
                /*an der Stelle k->m ist steht schon ein Baum*/
                if(a[k->m]->d <= k->d){
                    /*der bestehende Baum hat einen kleineren Schluesselwert als
                    der einzuordnende Baum, der einzuordnende Baum wird Kind des
                    bestehenden*/
                    Ele* b = k->r;

                    if(a[k->m]->next == NULL){
                        a[k->m]->next = k;
                        k->l = k;
                        k->r = k;
                    }
                    else{
                        k->l = a[k->m]->next->l;
                        k->r = a[k->m]->next;
                        k->l->r = k;
                        a[k->m]->next->l = k;
                    }

                    if(a[k->m]->m < k->m + 1){
                        /*der bestehende Baum steht jetzt leider an der falschen
                        Stelle im Array, da sein Grad gewachsen ist, er muss neu
                        eingeordnet werden*/
                        a[k->m]->r = b;		//damit alle noch einzuordnenden
                                            //WurzElelemente verarbeitet werden
                        a[k->m]->m = k->m + 1;
                        k = a[k->m];
                        a[k->m-1] = NULL;
                    }
                    else
                        /*sonst mit dem naechsten WurzElelement fortfahren*/
                        k = b;
                }
                else{
                    /*der bestehende Baum hat einen groesseren Schluesselwert als
                    der einzuordnende Baum, der bestehende Baum wird Kind des
                    einzuordnenden Baum, der einzuordnende Baum bestetzt a[k->m]*/
                    if(k->next == NULL){
                        k->next = a[k->m];
                        a[k->m]->l = a[k->m];
                        a[k->m]->r = a[k->m];
                    }
                    else{
                        a[k->m]->l = k->next->l;
                        a[k->m]->r = k->next;
                        a[k->m]->l->r = a[k->m];
                        k->next->l = a[k->m];
                    }
                    if(a[k->m]->m + 1 > k->m){
                        /*der neu eingeordnete Baum steht jetzt leider an der
                        falschen Stelle im Array, da sein Grad gewachsen ist, er
                        muss neu eingeordnet werden*/
                        int b = k->m;
                        k->m = a[b]->m + 1;
                        a[b] = NULL;
                    }
                    else{
                        a[k->m] = k;
                        k = k->r;
                    }
                }
            }
        }

        /*neue Wurzelliste zusammensetzen, nebenbei neues MinimalElement finden*/
        m = NULL;
        long int i = 0;
        while(m == NULL){
            if(a[i] != NULL)
                m = a[i];
            i++;
        }
        m->l = m;
        m->r = m;
        for(; i < N; i++)
            if (a[i] != NULL){
                a[i]->l = m->l;
                a[i]->r = m;
                a[i]->l->r = a[i];
                a[i]->r->l = a[i];
                if(a[i]->d < m->d)
                    m = a[i];
            }
        delete a;
    }
}
int FibHeap::size(){
    return int(n);
}
