﻿
#include "HeightData.h"
#define PI 3.14159265
#define RO 6371000
#define a 6378137
#define b 6356752.314
#define UTMScaleFactor 0.9996


HeightData::HeightData(){
	nReserve = 2;
	sx = sy = -1;
	grid = NULL;
    gcount = 20000;
    gcount = 3600;
    //gcount = 5500;
    //gcount = 1200;
    gcountf = 1.*gcount;
    h_scale = 1.;
}
void HeightData::set_rect(double minlat,double maxlat,double minlon,double maxlon){
    if(minlat > maxlat) maxlat = minlat = 0;
    if(minlon > maxlon) maxlon = minlon = 0;
    DEMRect.minlat = minlat;
	DEMRect.maxlat = maxlat;
	DEMRect.minlon = minlon;
	DEMRect.maxlon = maxlon;
}
HeightData::~HeightData(void){
	free_grid();
}
void HeightData::create_grid(){
	free_grid();
    int xminlon = floor(DEMRect.minlon*gcount);
    int xmaxlon = floor(DEMRect.maxlon*gcount);
    int yminlat = floor(DEMRect.minlat*gcount);
    int ymaxlat = floor(DEMRect.maxlat*gcount);
	GridRect.minlon = xminlon-nReserve;
	GridRect.minlat = yminlat-nReserve;
	GridRect.maxlon = xmaxlon+nReserve+1;
	GridRect.maxlat = ymaxlat+nReserve+1;
	sx = GridRect.maxlon-GridRect.minlon+1;
	sy = GridRect.maxlat-GridRect.minlat+1;

    grid = new float*[sy];
	for(int i = 0; i < sy; i++){
        grid[i] = new float[sx];
		for( int j = 0; j < sx; j++)
			grid[i][j] = -10000;
	}
    int data_voids = 0;
	
	/*Gitter auslesen*/
    for( int lon = floor(GridRect.minlon/gcountf); lon <= floor(GridRect.maxlon/gcountf);lon++)
        for( int lat = floor(GridRect.minlat/gcountf); lat <= floor(GridRect.maxlat/gcountf);lat++){
			char filename[12];
			char path[1000];
			if(lat < 0 && lon < 0)   sprintf(&(filename[0]),"S%02iW%03i.hgt",-lat,-lon);
			if(lat < 0 && lon >= 0)  sprintf(&(filename[0]),"S%02iE%03i.hgt",-lat, lon);
			if(lat >= 0 && lon < 0)  sprintf(&(filename[0]),"N%02iW%03i.hgt", lat,-lon);
			if(lat >= 0 && lon >= 0) sprintf(&(filename[0]),"N%02iE%03i.hgt", lat, lon);

			strcpy(path,SRTM3folder);
			strcat(path,"\\");
			strcat(path,filename);

            int ystart = (lat + 1) * gcount - max(GridRect.minlat, lat    * gcount);
            int yend   = (lat + 1) * gcount - min(GridRect.maxlat,(lat+1) * gcount);
            int yos    = (lat + 1) * gcount - GridRect.minlat;
            int xstart = max(lon     * gcount,GridRect.minlon) - lon * gcount;
            int xend   = min((lon+1) * gcount,GridRect.maxlon) - lon * gcount;
			int xread  = xend - xstart + 1;
            int xos    = max(lon     * gcount,GridRect.minlon) - GridRect.minlon;

			FILE* f = fopen(path,"rb");
            short* buf = new short[xread];
            short buft;
			if(f != NULL){
				/*Datei existiert*/
				for(int y = ystart; y >= yend; y--){
                    fseek(f,2*((gcount+1)*y+xstart),SEEK_SET);
                    fread(buf,2,xread,f);
                    for(int x = xos; x < xos + xread; x++){
                        buft = buf[x-xos];
                        grid[yos-y][x] = float((((buft)>>8)&0xff)+(((buft) << 8)&0xff00))/h_scale;
                        //if(grid[yos-y][x] == 0) data_voids++;
                    }
				}
				fclose(f);
			}
			else
				/*falls Datei nicht existiert alle Null setzen*/
				for(int y = ystart; y >= yend; y--)
					for(int x = xos; x < xos + xread; x++)
						grid[yos-y][x]=0;
            delete buf;
		}

    /*if(data_voids){
        int data_voids_prev;
        do{
            data_voids_prev = data_voids;
            for(int y = 0; y < sy; y++)
                for(int x = 0; x < sx; x++){
                    if(grid[y][x] == 0){
                        float newheight = 0;
                        float nbs = 0;
                        int d = 10;
                        bool height_now = false;
                        for(int yy = qMin(sy-1,y+20); yy >= qMax(0,y-20); yy--)
                            for(int xx = qMax(0,x-20); xx <= qMin(sx-1,x+20); xx++)
                                if(grid[yy][xx] > 0){
                                    double dnbs = 1./(((x-xx)*(x-xx)+(y-yy)*(y-yy)));
                                    nbs += dnbs;
                                    newheight += grid[yy][xx]*dnbs;
                                    if(dnbs >= 0.1)
                                        height_now = true;
                                }
                        if(height_now){
                            grid[y][x] = - newheight / nbs;
                            data_voids--;
                        }
                    }
                }
            for(int y = 0; y < sy; y++)
                for(int x = 0; x < sx; x++)
                    if(grid[y][x] < 0)
                        grid[y][x] *= -1;

        }while(data_voids > 0 && (data_voids_prev > data_voids));
    }*/
    //for(int y = 0; y < sy; y++){
    //    for( int x = 1; x < sx; x++)
    //        grid[y][x-1] = abs(grid[y][x]-grid[y][x-1]);
            //cbs.append(QString("%1\t").arg(grid[sy-y-1][x]));
        //cbs.append("\n");
    //}
    //QApplication::clipboard()->setText(cbs);
}
void HeightData::remove_wave_artifacts(){
    float** gri = new float*[sy];
    for(int i = 0; i < sy; i++){
        gri[i] = new float[sx];
        for( int j = 0; j < sx; j++)
            gri[i][j] = grid[i][j];
    }

    for(int y = 2; y+2 < sy; y++)
        for( int x = 2; x+2 < sx; x++){
            double fac = 0;
            double c[5] = {1,-4,6,-4,1};
            for(int dx = 0; dx < 5; dx++)
                for(int dy = 0; dy < 5; dy++)
                    fac += grid[y-2+dy][x-2+dx]*c[dx];
            fac = qMin(20.,qMax(fac,-20.));
            gri[y][x] = grid[y][x]-fac/40.;
        }

    for(int y = 2; y+2 < sy; y++)
        for( int x = 2; x+2 < sx; x++)
            if(x % 2 == 0 )
            //if(rand()%100 > 50 && x % 2 == 0 )
            grid[y][x] = gri[y][x];

    for(int i = 0; i < sy; i++)
        delete gri[i];
    delete gri;
}
void HeightData::free_grid(){
	if(grid != NULL){
		for(int i = 0; i < sy; i++)
            delete grid[i];
		if(sy>0)
            delete grid;
		grid = NULL;
	}
}
int HeightData::lty(double lat){
    return floor(gcount*lat) - GridRect.minlat;
}
int HeightData::ltx(double lon){
    return floor(gcount*lon) - GridRect.minlon;
}
double HeightData::ltdy(double lat){
    return (gcount*lat - floor(gcount*lat));
}
double HeightData::ltdx(double lon){
    return (gcount*lon - floor(gcount*lon));
}
void HeightData::interpolate_bicubic_conv3(int width,int height,double alpha,
										   double** h, double** dhdx, double** dhdy){
	nReserve = 3;
	create_grid();

	/*Rechenhilfen vorberechnen*/
	double dlon = DEMRect.maxlon - DEMRect.minlon;
	double dlat = DEMRect.maxlat - DEMRect.minlat;
    CubicKernel3* kx = new CubicKernel3[width];
    CubicKernel3* kxx = new CubicKernel3[width];
	for(int x = 0; x < width; x++){
		kxx[x].index[2] = kx[x].index[2] = ltx(1.*x/(width-1)*dlon + DEMRect.minlon);
		kxx[x].index[0] = kx[x].index[0] = kx[x].index[2] - 2;
		kxx[x].index[1] = kx[x].index[1] = kx[x].index[2] - 1;
		kxx[x].index[3] = kx[x].index[3] = kx[x].index[2] + 1;
		kxx[x].index[4] = kx[x].index[4] = kx[x].index[2] + 2;
		kxx[x].index[5] = kx[x].index[5] = kx[x].index[2] + 3;
		double dx = ltdx(1.*x/(width-1)*dlon + DEMRect.minlon);
		kx[x].weights[0] = Cubic_conv_kernel3(dx+2);
		kx[x].weights[1] = Cubic_conv_kernel3(dx+1);
		kx[x].weights[2] = Cubic_conv_kernel3(dx+0);
		kx[x].weights[3] = Cubic_conv_kernel3(dx-1);
		kx[x].weights[4] = Cubic_conv_kernel3(dx-2);
		kx[x].weights[5] = Cubic_conv_kernel3(dx-3);
		kxx[x].weights[0] = Cubic_conv_kernel3_d(dx+2);
		kxx[x].weights[1] = Cubic_conv_kernel3_d(dx+1);
		kxx[x].weights[2] = Cubic_conv_kernel3_d(dx+0);
		kxx[x].weights[3] = Cubic_conv_kernel3_d(dx-1);
		kxx[x].weights[4] = Cubic_conv_kernel3_d(dx-2);
		kxx[x].weights[5] = Cubic_conv_kernel3_d(dx-3);
	}

    CubicKernel3* ky = new CubicKernel3[height];
    CubicKernel3* kyy = new CubicKernel3[height];
	for(int y = 0; y < height; y++){
		kyy[y].index[2] = ky[y].index[2] = lty(1.*y/(height-1)*dlat + DEMRect.minlat);
		kyy[y].index[0] = ky[y].index[0] = ky[y].index[2] - 2;
		kyy[y].index[1] = ky[y].index[1] = ky[y].index[2] - 1;
		kyy[y].index[3] = ky[y].index[3] = ky[y].index[2] + 1;
		kyy[y].index[4] = ky[y].index[4] = ky[y].index[2] + 2;
		kyy[y].index[5] = ky[y].index[5] = ky[y].index[2] + 3;
		double dy = ltdy(1.*y/(height-1)*dlat + DEMRect.minlat);
		ky[y].weights[0] = Cubic_conv_kernel3(dy+2);
		ky[y].weights[1] = Cubic_conv_kernel3(dy+1);
		ky[y].weights[2] = Cubic_conv_kernel3(dy+0);
		ky[y].weights[3] = Cubic_conv_kernel3(dy-1);
		ky[y].weights[4] = Cubic_conv_kernel3(dy-2);
		ky[y].weights[5] = Cubic_conv_kernel3(dy-3);
		kyy[y].weights[0] = Cubic_conv_kernel3_d(dy+2);
		kyy[y].weights[1] = Cubic_conv_kernel3_d(dy+1);
		kyy[y].weights[2] = Cubic_conv_kernel3_d(dy+0);
		kyy[y].weights[3] = Cubic_conv_kernel3_d(dy-1);
		kyy[y].weights[4] = Cubic_conv_kernel3_d(dy-2);
		kyy[y].weights[5] = Cubic_conv_kernel3_d(dy-3);
	}
	if(h != NULL){
		for(int x = 0; x < width; x++)
			for(int y = 0; y < height; y++){
				h   [x][height-1-y] = Bicubic_conv3(kx [x],ky [y]);
				/*fuer genaue aber halb so schnelle Berechnung folgende 2 Zeilen
				aktivieren*/
				//dhdx[x][height-1-y] = Bicubic_conv3(kxx[x],ky [y]);
				//dhdy[x][height-1-y] = Bicubic_conv3(kx [x],kyy[y]);
			}
	}
	free_grid();
    delete(kx);
    delete(kxx);
    delete(ky);
    delete(kyy);
	/*hier die schnell-Berechnung des Gradienten*/
	if(dhdx != NULL){
        double pxperx = width/((DEMRect.maxlon-DEMRect.minlon)*1200);
		for(int x = 1; x < width-1; x++)
			for(int y = 1; y < height-1; y++)
				dhdx[x][y] = (h[x+1][y]-h[x-1][y])/2.*pxperx;
		for(int i = 0 ; i < width; i++)
			dhdx[i][0] = dhdx[i][height-1] = 0;
	}
	if(dhdy != NULL){
        double pxpery = height/((DEMRect.maxlat-DEMRect.minlat)*1200);
		for(int x = 1; x < width-1; x++)
			for(int y = 1; y < height-1; y++)
				dhdy[x][y] = (h[x][y+1]-h[x][y-1])/2.*pxpery;
		for(int i = 0 ; i < height; i++)
			dhdy[0][i] = dhdy[width-1][i] = 0;
	}
}
void HeightData::interpolate_bicubic_conv3_mercator(int width,int height,
                                                    double alpha,double** h,
                                                    double** dhdx, double** dhdy){
    nReserve = 3;
    create_grid();
    if(gcount > 1200)
        relax_grid();
    if(gcount == 3600)
        remove_wave_artifacts();        // SRTM1 data suffers from wave profil
    /*Rechenhilfen vorberechnen*/
    double dlon = DEMRect.maxlon - DEMRect.minlon;
    CubicKernel3* kx = new CubicKernel3[width];
    CubicKernel3* kxx = new CubicKernel3[width];
    for(int x = 0; x < width; x++){
        kxx[x].index[2] = kx[x].index[2] = ltx((0.5+x)/width*dlon + DEMRect.minlon);
        kxx[x].index[0] = kx[x].index[0] = kx[x].index[2] - 2;
        kxx[x].index[1] = kx[x].index[1] = kx[x].index[2] - 1;
        kxx[x].index[3] = kx[x].index[3] = kx[x].index[2] + 1;
        kxx[x].index[4] = kx[x].index[4] = kx[x].index[2] + 2;
        kxx[x].index[5] = kx[x].index[5] = kx[x].index[2] + 3;
        double dx = ltdx((0.5+x)/width * dlon + DEMRect.minlon);
        kx[x].weights[0] = Cubic_conv_kernel3(dx+2);
        kx[x].weights[1] = Cubic_conv_kernel3(dx+1);
        kx[x].weights[2] = Cubic_conv_kernel3(dx+0);
        kx[x].weights[3] = Cubic_conv_kernel3(dx-1);
        kx[x].weights[4] = Cubic_conv_kernel3(dx-2);
        kx[x].weights[5] = Cubic_conv_kernel3(dx-3);
        kxx[x].weights[0] = Cubic_conv_kernel3_d(dx+2);
        kxx[x].weights[1] = Cubic_conv_kernel3_d(dx+1);
        kxx[x].weights[2] = Cubic_conv_kernel3_d(dx+0);
        kxx[x].weights[3] = Cubic_conv_kernel3_d(dx-1);
        kxx[x].weights[4] = Cubic_conv_kernel3_d(dx-2);
        kxx[x].weights[5] = Cubic_conv_kernel3_d(dx-3);
    }

    double* ylat = new double[height];
    CubicKernel3* ky = new CubicKernel3[height];
    CubicKernel3* kyy = new CubicKernel3[height];
    double mmax = lattomercator(DEMRect.maxlat);
    double mmin = lattomercator(DEMRect.minlat);
    double dlat = mmax - mmin;
    for(int y = 0; y < height; y++){
        ylat[y] = mercatortolat((0.5+y)/height*dlat + mmin);
        kyy[y].index[2] = ky[y].index[2] = lty(ylat[y]);
        kyy[y].index[0] = ky[y].index[0] = ky[y].index[2] - 2;
        kyy[y].index[1] = ky[y].index[1] = ky[y].index[2] - 1;
        kyy[y].index[3] = ky[y].index[3] = ky[y].index[2] + 1;
        kyy[y].index[4] = ky[y].index[4] = ky[y].index[2] + 2;
        kyy[y].index[5] = ky[y].index[5] = ky[y].index[2] + 3;
        double dy = ltdy(ylat[y]);
        ky[y].weights[0] = Cubic_conv_kernel3(dy+2);
        ky[y].weights[1] = Cubic_conv_kernel3(dy+1);
        ky[y].weights[2] = Cubic_conv_kernel3(dy+0);
        ky[y].weights[3] = Cubic_conv_kernel3(dy-1);
        ky[y].weights[4] = Cubic_conv_kernel3(dy-2);
        ky[y].weights[5] = Cubic_conv_kernel3(dy-3);
        kyy[y].weights[0] = Cubic_conv_kernel3_d(dy+2);
        kyy[y].weights[1] = Cubic_conv_kernel3_d(dy+1);
        kyy[y].weights[2] = Cubic_conv_kernel3_d(dy+0);
        kyy[y].weights[3] = Cubic_conv_kernel3_d(dy-1);
        kyy[y].weights[4] = Cubic_conv_kernel3_d(dy-2);
        kyy[y].weights[5] = Cubic_conv_kernel3_d(dy-3);
    }
    if(h != NULL){
        for(int x = 0; x < width; x++)
            for(int y = 0; y < height; y++){
                h   [x][height-1-y] = Bicubic_conv3(kx [x],ky [y]);
                /*fuer genaue aber halb so schnelle Berechnung folgende 2 Zeilen
                aktivieren*/
                //dhdx[x][height-1-y] = Bicubic_conv3(kxx[x],ky [y]);
                //dhdy[x][height-1-y] = Bicubic_conv3(kx [x],kyy[y]);
            }
    }
    free_grid();
    delete(kx);
    delete(kxx);
    delete(ky);
    delete(kyy);
    /*hier die schnell-Berechnung des Gradienten*/
    if(dhdx != NULL){
        double pxperx = width/((DEMRect.maxlon-DEMRect.minlon)
                               *111
                               *cos((DEMRect.maxlat+DEMRect.minlat)/2));
        for(int x = 1; x < width-1; x++)
            for(int y = 1; y < height-1; y++)
                dhdx[x][y] = (h[x+1][y]-h[x-1][y])/2.*pxperx;
        for(int i = 0 ; i < width; i++)
            dhdx[i][0] = dhdx[i][height-1] = 0;
    }
    if(dhdy != NULL){
        double pxpery;// = height/((DEMRect.maxlat-DEMRect.minlat)*gcountf);

        for(int y = 1; y < height-1; y++){
            pxpery = 2./((ylat[y+1]-ylat[y-1])*111);
            for(int x = 1; x < width-1; x++)
                dhdy[x][y] = (h[x][y+1]-h[x][y-1])/2.*pxpery;
        }
        for(int i = 0 ; i < height; i++)
            dhdy[0][i] = dhdy[width-1][i] = 0;
    }
    delete ylat;
}
inline double HeightData::Cubic_conv_kernel3(double x){
	if(x >= 3) return 0;
    if(x > 2) return  x*x*x/12.   -2.*x*x/3.+21.*x/12.-3./2.;
    if(x > 1) return -7.*x*x*x/12.+3.*x*x   -59.*x/12.+15./6.;
    if(x > 0) return  4.*x*x*x/3. -7.*x*x/3.          +1.;
    if(x >-1) return -4.*x*x*x/3. -7.*x*x/3.          +1.;
    if(x >-2) return  7.*x*x*x/12.+3.*x*x   +59.*x/12.+15./6.;
    if(x >-3) return -x*x*x/12.   -2.*x*x/3.-21.*x/12.-3./2.;
    else return 0;
}
inline double HeightData::Cubic_conv_kernel3_d(double x){
    if(x >= 3) return 0;
    if(x > 2) return  3*x*x/12.   -2.*2*x/3.+21.*1/12.;
    if(x > 1) return -7.*3*x*x/12.+3.*2*x   -59.*1/12.;
    if(x > 0) return  4.*3*x*x/3. -7.*2*x/3.;
    if(x >-1) return -4.*3*x*x/3. -7.*2*x/3.;
    if(x >-2) return  7.*3*x*x/12.+3.*2*x   +59.*1/12.;
    if(x >-3) return -3*x*x/12.   -2.*2*x/3.-21.*1/12.;
    else return 0;
}
inline double HeightData::Bicubic_conv3(CubicKernel3 kx, CubicKernel3 ky){
	double result = 0;
	for( int x = 0; x < 6; x++)
		for(int y = 0; y < 6; y++)
			result = result + grid[ky.index[y]][kx.index[x]] 
							  * kx.weights[x] * ky.weights[y];
	return result;
}
void HeightData::set_SRTM3_folder(char* folder){
	strcpy(SRTM3folder,folder);
    gcount = 1200;
    gcountf = 1.*gcount;
    h_scale = 1;
}
void HeightData::set_SRTM1_folder(char* folder){
    strcpy(SRTM3folder,folder);
    gcount = 3600;
    gcountf = 1.*gcount;
    h_scale = 1;
}
void HeightData::set_SRTM066_folder(char* folder){
    strcpy(SRTM3folder,folder);
    gcount = 5500;
    gcountf = 1.*gcount;
    h_scale = 32;
}
void HeightData::set_SRTM018_folder(char* folder){
    strcpy(SRTM3folder,folder);
    gcount = 20000;
    gcountf = 1.*gcount;
    h_scale = 32;
}
void HeightData::reset_t(double minlat,double maxlat,double minlon,double maxlon){
	nReserve = 3;
	set_rect(minlat,maxlat,minlon,maxlon);
	create_grid();
}
int HeightData::max_t(){
	int result = -10000;
	if(grid != NULL){
		result = int(grid[0][0]);
		for(int y = 0; y < sy; y++)
			for( int x = 0; x < sx; x++)
				if(grid[y][x] > result)
					result = grid[y][x];
	}
	return result;
}
int HeightData::max_dt(){
    int min,max;
    if(grid != NULL){
        min = max = int(grid[0][0]);
        for(int y = 0; y < sy; y++)
            for( int x = 0; x < sx; x++){
                if(grid[y][x] > max)
                    max = grid[y][x];
                if(grid[y][x] < min)
                    min = grid[y][x];
            }
        return max-min;
    }
    else
        return 0;
}
double HeightData::height_t_save(double lon,double lat,void* hc,short mode){
    if(lon > DEMRect.minlon &&
       lon < DEMRect.maxlon &&
       lat > DEMRect.minlat &&
       lat < DEMRect.maxlat)
        return height_t(lon,lat,hc,mode);
    else return 0;
}

double HeightData::height_t(double lon,double lat,void* hc,short mode){
	CubicKernel3 kx;
	kx.index[2] = ltx(lon);
	kx.index[0] = kx.index[2] - 2;
	kx.index[1] = kx.index[2] - 1;
	kx.index[3] = kx.index[2] + 1;
	kx.index[4] = kx.index[2] + 2;
	kx.index[5] = kx.index[2] + 3;
	CubicKernel3 ky;
	ky.index[2] = lty(lat);
	ky.index[0] = ky.index[2] - 2;
	ky.index[1] = ky.index[2] - 1;
	ky.index[3] = ky.index[2] + 1;
	ky.index[4] = ky.index[2] + 2;
	ky.index[5] = ky.index[2] + 3;

	double dx = ltdx(lon);
	double dy = ltdy(lat);

	/*kontrolliere, dass indeces im grid enthalten sind*/
	if(ky.index[0] < 0 || ky.index[5] >= sy || 
	   kx.index[0] < 0 || kx.index[5] >= sx)
	   return 0;

    double h = 0,dhdx=0,dhdy=0;
	if(mode == 0 || hc != NULL){
		/*einfache Hoehe berechnen*/
		for(int i = 0; i < 6; i++){
			kx.weights[i] = Cubic_conv_kernel3(dx+2-i);
			ky.weights[i] = Cubic_conv_kernel3(dy+2-i);
		}
        h = Bicubic_conv3(kx,ky);
    }
	if(mode == 1 || mode == 3 || mode == 4){
		/*Ableitung in x berechnen*/
		for(int i = 0; i < 6; i++){
			kx.weights[i] = Cubic_conv_kernel3_d(dx+2-i);
            ky.weights[i] = Cubic_conv_kernel3  (dy+2-i);
		}
        dhdx = Bicubic_conv3(kx,ky);
	}
	if(mode == 2 || mode == 3 || mode == 4){
		/*Ableitung in y ausgeben*/
		for(int i = 0; i < 6; i++){
            kx.weights[i] = Cubic_conv_kernel3  (dx+2-i);
			ky.weights[i] = Cubic_conv_kernel3_d(dy+2-i);
		}
		dhdy = Bicubic_conv3(kx,ky);
	}

	if(hc != NULL)						//Hoehe mitgeben
		*((float*)hc) = h;
	if(mode == 0)						//Hoehe ausgeben
		return h;
	if(mode == 1)						//x-Ableitung ausgeben
		return dhdx;
	if(mode == 2)						//y-Ableitung ausgeben
		return dhdy;
	if(mode == 3)						//Gradientenrichtung ausgeben
		return atan2(double(dhdx),double(dhdy*cos(lat/180*PI)));
	if(mode == 4){						//Vertrauensindex mit- u. Hoehe ausgeben
		//((double*)hc)[0] = abs(((double*)hc)[2]*dhdy-((double*)hc)[1]*dhdx/cos(lat/180*PI));
		double hn[4];
		double dlat = 0.00007, dlon = dlat/cos(lat/180.*PI);
        hn[0] = height_t(lon-2*dlon*((double*)hc)[1],lat+2*dlat*((double*)hc)[2],NULL,0);
		hn[1] = height_t(lon-1*dlon*((double*)hc)[1],lat+1*dlat*((double*)hc)[2],NULL,0);
		hn[2] = height_t(lon+1*dlon*((double*)hc)[1],lat-1*dlat*((double*)hc)[2],NULL,0);
		hn[3] = height_t(lon+2*dlon*((double*)hc)[1],lat-2*dlat*((double*)hc)[2],NULL,0);
		((double*)hc)[0]= (2*hn[0]-hn[1]-2*h-hn[2]+2*hn[3])/14.*
                          qAbs(((double*)hc)[2]*dhdy-((double*)hc)[1]*dhdx/cos(lat/180*PI));
		return h;
	}
    else
        return 0;
}
double HeightData::height(double lon,double lat,void* hc,short mode){
	set_rect(lat,lat,lon,lon);
	nReserve = 3;
	create_grid();
	double result = height_t(lon,lat,hc,mode);
	free_grid();
	return result;
}
double HeightData::simple_height(double lon,double lat){
    set_rect(lat,lat,lon,lon);
    nReserve = 0;
    double dx = lon*gcount - floor(lon*gcount);
    double dy = lat*gcount - floor(lat*gcount);
    create_grid();
    double result =   grid[1][1]*dx     *dy
                    + grid[0][1]*dx     *(1-dy)
                    + grid[1][0]*(1-dx) *dy
                    + grid[0][0]*(1-dx) *(1-dy);
    //result = grid[1][0]*(1-dx)+grid[1][1]*(dx);
    free_grid();
    return result;
}

void HeightData::paek_pro(double lon, double lat, qint64** c,float* Ahigher,
						  int cc, int ac,float d,float mperlon, float mperlat){
	int j,i,x,y,ymin,ymax,xmin,xmax, Ac = 0, AcF = 0;
    float x0 = lon*gcount - GridRect.minlon;	//Gipfellage
    float y0 = lat*gcount - GridRect.minlat;
	float sx = mperlon/1000;			//Skalierung km je x
	float sy = mperlat/1000;			//Saklierung km je y
	float h0 = height_t(lon,lat,NULL,0);

	/*Punktzaehler anlegen*/
    int **wc = new int*[ac];
 	for(i = 0; i < ac; i++)
        wc[i] = new int[cc];

	/*Höhenzaehler und Punktzaehler initialisieren*/
	for(i = 0; i < ac; i++)
		for(j = 0; j < cc; j++){
			c[i][j] = 0;					//Zählt alle Höhen
			wc[i][j] = 0;					//Anzahl enthaltener Punkte
		}

    xmin = qMax(0         ,int(floor(x0-(d*cc)/sx)));
    xmax = qMin(this->sx-1,int (ceil(x0+(d*cc)/sx)));
	for(x = xmin; x <= xmax; x++){
        ymin = qMax(0    ,int(floor(y0-sqrt((d*cc*d*cc)-((x-x0)*sx*(x-x0)*sx)+1)/sx)));
        ymax = qMin(this->sy-1,int(ceil (y0+sqrt((d*cc*d*cc)-((x-x0)*sx*(x-x0)*sx)+1)/sx)));
		for(y = ymin; y <= ymax;  y++){
			i = int(floor((atan2(y-y0,x-x0)/PI+1)/2*ac));
			j = int(floor(sqrt(((y-y0)*sy*(y-y0)*sy)+((x-x0)*sx*(x-x0)*sx))/d));
            if(i < cc && grid[y][x] < 9000
			   && i < ac && j < cc){
				c[i][j] = c[i][j] + long(grid[y][x]);
				wc[i][j]++;
				if(grid[y][x] > h0) Ac++;
				AcF++;
			}
		}
	}
	/*Durchschnitt bilden*/
	for(i = 0; i < ac; i++)
		for(j = 0; j < cc; j++)
			if(wc[i][j] > 0)
				c[i][j] = c[i][j] / wc[i][j];
			else
                c[i][j] = 13000;
	
	/*Punktzaehler löschen*/
	for(i = 0; i < ac; i++)
        delete(wc[i]);
    delete(wc);

	*Ahigher = float(1.*Ac/AcF);

}
void HeightData::interpolate_linear(int width,int height,double alpha,
							double** h, double** dhdx, double** dhdy){
	nReserve = 3;
	create_grid();
	
	int ix,iy;
	for(int x = 0; x < width; x++)
		for(int y = 0; y < height; y++){
			ix = ltx(DEMRect.minlon + (DEMRect.maxlon-DEMRect.minlon)*(1.*x/(width -1)));
			iy = lty(DEMRect.minlat + (DEMRect.maxlat-DEMRect.minlat)*(1.*y/(height-1)));
			h[x][height-1-y]	   = 1.*( + grid[iy  ][ix] + grid[iy  ][ix+1]
							  + grid[iy+1][ix] + grid[iy+1][ix+1])/4.;
			dhdx[x][height-1-y] = 1.*( - grid[iy  ][ix] + grid[iy  ][ix+1]
						      - grid[iy+1][ix] + grid[iy+1][ix+1])/2.;
			dhdy[x][height-1-y] =-1.*( - grid[iy  ][ix] - grid[iy  ][ix+1]
						      + grid[iy+1][ix] + grid[iy+1][ix+1])/2.;
		}
}
void HeightData::interpolate_linear_mercator(int width,int height,double alpha,
                            double** h, double** dhdx, double** dhdy){
    nReserve = 3;
    create_grid();
    double mmax = lattomercator(DEMRect.maxlat);
    double mmin = lattomercator(DEMRect.minlat);
    int ix,iy;
    double pxperx = width/((DEMRect.maxlon-DEMRect.minlon)
                           *111
                           *cos(rad((DEMRect.maxlat+DEMRect.minlat)/2.)));
    double pxpery = height/((DEMRect.maxlat-DEMRect.minlat)*111);
    for(int y = 0; y < height; y++){
        iy = lty(mercatortolat(mmin + (mmax-mmin)*((0.5+y)/height)));
        for(int x = 0; x < width; x++){
            ix = ltx(DEMRect.minlon + (DEMRect.maxlon-DEMRect.minlon)*((0.5+x)/width));
            h[x][height-1-y]	   = 1.*( + grid[iy  ][ix] + grid[iy  ][ix+1]
                              + grid[iy+1][ix] + grid[iy+1][ix+1])/4.;
            dhdx[x][height-1-y] = 1.*( - grid[iy  ][ix] + grid[iy  ][ix+1]
                              - grid[iy+1][ix] + grid[iy+1][ix+1])/2.*pxperx;
            dhdy[x][height-1-y] =-1.*( - grid[iy  ][ix] - grid[iy  ][ix+1]
                              + grid[iy+1][ix] + grid[iy+1][ix+1])/2.*pxpery;
        }
    }
}

void HeightData::get_sorted_grid_data(short** heights, int** lons, int** lats,
                                      int** gradx, int** grady, long* count){
	/*extracts all grid values with KOO into three list, sorted by height
	beginning with the highest*/
	*count = sy*sx;
	qsh = *heights = new short[*count];
    qslon = *lons = new int[*count];
    qslat= *lats = new int[*count];
    qsx= *gradx = new int[*count];
    qsy= *grady = new int[*count];
    int x,y,deadlevel;
    double h0,dh,dht,Acorr,gcorr,dtt;
	/*Extracting*/
    for(int ii = 0; ii < sy; ii++){
        (*lats)[ii*sx] = 1.*(GridRect.minlat+ii)/gcountf;
        Acorr = cos((*lats)[ii*sx]*0.0174532922);
        gcorr = 1./sqrt(Acorr*Acorr+1);
        Acorr = 1./Acorr;
        for( int jj = 0; jj < sx; jj++){
			(*heights)[ii*sx+jj] = grid[ii][jj];
            (*lons)[ii*sx+jj] = jj;
            (*lats)[ii*sx+jj] = ii;
            //now trace uphill
            deadlevel = 1;
            h0 = grid[ii][jj];
            x = jj;
            y = ii;
            if(y > 0 && y < sy-1 && sx > 0 && x < sx-1){
                dh = 0;
                deadlevel = 1;
                int gt[8][2] = {{-1,-1},{-1,+1},{+1,-1},{+1,+1},
                                {0,-1},{0,+1},{+1,0},{-1,0}};
                double gf[8];
                gf[0] = gcorr;
                gf[1] = gcorr;
                gf[2] = gcorr;
                gf[3] = gcorr;
                gf[4] = Acorr;
                gf[5] = Acorr;
                gf[6] = 1;
                gf[7] = 1;

                dh = 0;

                for(int j = 0; j < 8; j++){
                    dtt = (grid[ii+gt[j][0]][jj+gt[j][1]]-h0)*gf[j];
                    if(dtt > dh){
                        dh = dtt;
                        x = jj+gt[j][1];
                        y = ii+gt[j][0];
                    }
                    if(dtt != dh)
                        deadlevel = 0;
                }
            }
            if(!deadlevel){
                (*gradx)[ii*sx+jj] = x;
                (*grady)[ii*sx+jj] = y;
            }
            else{
                (*gradx)[ii*sx+jj] = -1;
                (*grady)[ii*sx+jj] = -1;
            }
		}
    }
	/*QuickSort*/
	sort_GridList(0,*count-1);
}
void HeightData::sort_GridList(long s, long e){
	short sb;
    int ib;
	long l = s, r = e;
	double p = qsh[(s+e)/2], db;
	do{
		while(qsh[l] < p) l++;
		while(qsh[r] > p) r--;
		if(l<=r){
			sb = qsh[l]; qsh[l] = qsh[r]; qsh[r] = sb;
			db = qslon[l]; qslon[l] = qslon[r]; qslon[r] = db;
			db = qslat[l]; qslat[l] = qslat[r]; qslat[r] = db;
            ib = qsx[l]; qsx[l] = qsx[r]; qsx[r] = ib;
            ib = qsy[l]; qsy[l] = qsy[r]; qsy[r] = ib;
			l++;
			r--;
		}
	}while(l <= r);
	if(s < r) sort_GridList(s,r);
	if(l < e) sort_GridList(l,e);
}
recti HeightData::get_GridRect(){
	return GridRect;
}
int HeightData::correct_hgt(char* filename){
    char fn[100];
    short badheight = -1000;
    int lnl = strlen(filename);
    strcpy(&(fn[0]),&(filename[strlen(filename)-11]));
    int lon = -190,lat = -190;
    fn[7]='\0';
    if(fn[3]=='E') lon =   atoi(&(fn[4]));
    if(fn[3]=='W') lon = - atoi(&(fn[4]));
    fn[3]='\0';
    if(fn[0]=='N') lat =   atoi(&(fn[1]));
    if(fn[0]=='S') lat = - atoi(&(fn[1]));
    bool corrected = false;
    if(lon >= -180 && lon < 180 && lat >= -90 && lat < 90){
        set_rect(lat,lat+1,lon,lon+1);
        nReserve = 100;
        create_grid();
        for(int x = 99; x < 1300; x++)
            for(int y = 99; y < 1300; y++)
                if(grid[y][x] < badheight){
                    corrected = true;
                    int ym = y, yp = y, xm = x, xp = x;
                    double hy = badheight-100., hx = badheight-100.;
                    while(grid[ym][x] < badheight && ym > 0)    ym--;
                    while(grid[yp][x] < badheight && yp < sy-1) yp++;
                    while(grid[y][xm] < badheight && xm > 0)    xm--;
                    while(grid[y][xp] < badheight && xp < sx-1) xp++;
                    short y0 = grid[y][x];
                    short y1 = grid[yp][x];
                    short y2 = grid[ym][x];
                    short y3 = grid[y][xp];
                    short y4 = grid[y][xm];
                    if(grid[ym][x] > badheight && grid[yp][x] > badheight)
                        hy = ((yp-y)*grid[ym][x]+(y-ym)*grid[yp][x])/(yp-ym);
                    if(grid[ym][x] > badheight && grid[yp][x] > badheight)
                        hx = ((xp-x)*grid[y][xm]+(x-xm)*grid[y][xp])/(xp-xm);
                    if(hy > badheight && hx > badheight)
                        grid[y][x] = (hx+hy)/2;
                    else{
                        if(hy > badheight)
                            grid[y][x] = hy;
                        else
                            grid[y][x] = hx;
                    }
                }
        if(corrected){
            /*Datei existiert*/
            FILE* f = fopen(filename,"wb");
            short buf;
            for(int y = 1300; y >= 99; y--){
                for(int x = 99; x < 1300; x++){
                    buf = short(grid[y][x]);
                    buf = ((buf>>8)&0xff)+((buf << 8)&0xff00);
                }
                fwrite(&buf,2,(gcount+1),f);
            }
            fclose(f);
        }
        return corrected;
    }
    else
        return 0;
}
void HeightData::test_relax_grid(){
    float g0[7] = {2,2,2,2,2,2,2};
    float g1[7] = {2,2,2,2,2,2,2};
    float g2[7] = {2,2,2,2,2,2,2};
    float g3[7] = {1,1,1,1,1,1,1};
    float g4[7] = {1,1,1,1,1,1,1};
    float g5[7] = {1,1,1,1,1,1,1};
    float g6[7] = {1,1,1,1,1,1,1};
    float* gro[7];
    gro[0] = g0;
    gro[1] = g1;
    gro[2] = g2;
    gro[3] = g3;
    gro[4] = g4;
    gro[5] = g5;
    gro[6] = g6;
    grid = &(gro[0]);
    sx = 7;
    sy = 7;
    set_rect(0,0,0,0);
    relax_grid();
    relax_grid();
}

void HeightData::relax_grid(){
    // generate help grid
    float** gri0 = new float*[sy];
    for(int i = 0; i < sy; i++){
        gri0[i] = new float[sx];
        for( int j = 0; j < sx; j++)
            gri0[i][j] = grid[i][j];
    }
    // Kernel to calculate mean curvature
    float kx2[7][7] =
           {{-2.8782088967274E-6,2.3025671173819E-5,-3.5200494806976E-3,6.9998040368411E-3,-3.5200494806976E-3,2.3025671173819E-5,-2.8782088967274E-6},
            {2.3025671173819E-5,-1.8420536939056E-4,2.8160395845581E-2,-5.5998432294729E-2,2.8160395845581E-2,-1.8420536939056E-4,2.3025671173819E-5},
            {-1.4850333137370E-4,1.1880266509896E-3,-1.8161957427004E-1,3.6116010190084E-1,-1.8161957427004E-1,1.1880266509896E-3,-1.4850333137370E-4},
            {-7.7209484616892E-4,6.1767587693514E-3,-9.4427199686459E-1,1.8777346658828E+0,-9.4427199686459E-1,6.1767587693514E-3,-7.7209484616892E-4},
            {-1.4850333137370E-4,1.1880266509896E-3,-1.8161957427004E-1,3.6116010190084E-1,-1.8161957427004E-1,1.1880266509896E-3,-1.4850333137370E-4},
            {2.3025671173819E-5,-1.8420536939056E-4,2.8160395845581E-2,-5.5998432294729E-2,2.8160395845581E-2,-1.8420536939056E-4,2.3025671173819E-5},
            {-2.8782088967274E-6,2.3025671173819E-5,-3.5200494806976E-3,6.9998040368411E-3,-3.5200494806976E-3,2.3025671173819E-5,-2.8782088967274E-6}};

    float ky2[7][7] =
           {{-2.8782088967274E-6,2.3025671173819E-5,-1.4850333137370E-4,-7.7209484616892E-4,-1.4850333137370E-4,2.3025671173819E-5,-2.8782088967274E-6},
            {2.3025671173819E-5,-1.8420536939056E-4,1.1880266509896E-3,6.1767587693514E-3,1.1880266509896E-3,-1.8420536939056E-4,2.3025671173819E-5},
            {-3.5200494806976E-3,2.8160395845581E-2,-1.8161957427004E-1,-9.4427199686459E-1,-1.8161957427004E-1,2.8160395845581E-2,-3.5200494806976E-3},
            {6.9998040368411E-3,-5.5998432294729E-2,3.6116010190084E-1,1.8777346658828E+0,3.6116010190084E-1,-5.5998432294729E-2,6.9998040368411E-3},
            {-3.5200494806976E-3,2.8160395845581E-2,-1.8161957427004E-1,-9.4427199686459E-1,-1.8161957427004E-1,2.8160395845581E-2,-3.5200494806976E-3},
            {2.3025671173819E-5,-1.8420536939056E-4,1.1880266509896E-3,6.1767587693514E-3,1.1880266509896E-3,-1.8420536939056E-4,2.3025671173819E-5},
            {-2.8782088967274E-6,2.3025671173819E-5,-1.4850333137370E-4,-7.7209484616892E-4,-1.4850333137370E-4,2.3025671173819E-5,-2.8782088967274E-6}};

    for(double dh = 0.5; dh > 0.1; dh *= 0.5){
        for(int y = 3; y+3 < sy; y++)
            for( int x = 3; x+3 < sx; x++){
                // calculcate curvature for each grid point
                float dx2 = 0;
                float dy2 = 0;
                for(int dy = -3; dy < 4; dy++)
                    for( int dx = -3; dx < 4; dx++){
                        dx2 += grid[y+dy][x+dx] * kx2[dy+3][dx+3];
                        dy2 += grid[y+dy][x+dx] * ky2[dy+3][dx+3];
                    }
                float ax = kx2[3][3];
                float bx = dx2 - ax*grid[y][x];
                float ay = ky2[3][3];
                float by = dy2 - ay*grid[y][x];
                //imt = -1.*(ax+ay);
                //imt = -1.*(bx+by);
                //imt = -1.*(bx+by)/(ax+ay);
                gri0[y][x] = -(bx+by)/(ax+ay);//+grid[y][x];
                //gri0[y][x] = imt/10.0277777778 * 0.3 + grid[y][x] * 0.7;
                if(qAbs(gri0[y][x]-grid[y][x])>=dh){
                    if(gri0[y][x] > grid[y][x])
                        gri0[y][x] = grid[y][x] + dh;
                    else
                        gri0[y][x] = grid[y][x] - dh;
                }/**/
                /*
                if(d2p < d2m){
                    if(d2p < d20)
                        gri0[y][x] += dh*0.5;
                }
                else{
                    if(d2m < d20)
                        gri0[y][x] -= dh*0.5;
                }*/


            }
        // accept relaxation step
        for(int i = 0; i < sy; i++)
            for( int j = 0; j < sx; j++)
                grid[i][j] = gri0[i][j];
    }

    for(int i = 0; i < sy; i++)
        delete gri0[i];
    delete gri0;
}
void HeightData::DOM_to_SRTM(QString DOM_src_folder, QString SRTM_dest_folder,
                             int DOMresolution, int SRTMresolution){
    int s = DOMresolution;              // typically 2 or 20
    // get all UTM files
    QDir d(DOM_src_folder);
    d.setFilter(QDir::Files);
    QStringList el = d.entryList();
    for(int i = el.length()-1; i >= 0; i--)
        if(!(el[i].right(3)== "xyz")) el.removeAt(i);
    // determine max-min-rect
    int minx = 999999;
    int maxx = 0;
    int miny = 9999999;
    int maxy =-9999999;
    int x,y;
    for(int i = 0; i < el.length(); i++){
        QFile tfile(d.filePath(el[i]));
        if(tfile.open(QIODevice::ReadOnly)) {
            QTextStream in(&tfile);
            QString linefirst = in.readLine();
            QString linelast;
            while(!in.atEnd()) {
                linelast = in.readLine();
            }
            QStringList fields_first = linefirst.split(" ");
            QStringList fields_last = linelast.split(" ");
            bool OK;
            x = int(fields_first[0].toFloat(&(OK)));
            if(OK){
                minx = qMin(minx,x);
                maxx = qMax(maxx,x);
            }
            x =  int(fields_last[0].toFloat(&(OK)));
            if(OK){
                minx = qMin(minx,x);
                maxx = qMax(maxx,x);
            }
            y = int(fields_first[1].toFloat(&(OK)));
            if(OK){
                miny = qMin(miny,y);
                maxy = qMax(maxy,y);
            }
            y = int(fields_last[1].toFloat(&(OK)));
            if(OK){
                miny = qMin(miny,y);
                maxy = qMax(maxy,y);
            }

        }
        tfile.close();
    }
    // create and fill grid
    int uy = (maxy-miny)/s+1;
    int ux = (maxx-minx)/s+1;
    QList<float>* ugrid = new QList<float>[uy];
    for(int i = 0; i < uy; i++){
        for( int j = 0; j < ux; j++)
            ugrid[i].append(0.);
    }
    // read all UTM files
    //QList<UTM> ul;
    for(int i = 0; i < el.length(); i++){
        QFile tfile(d.filePath(el[i]));
        if(tfile.open(QIODevice::ReadOnly)) {
            QTextStream in(&tfile);
            while(!in.atEnd()) {
                QString line = in.readLine();
                QStringList fields = line.split(" ");
                x = int(fields[0].toFloat());
                y = int(fields[1].toFloat());
                ugrid[(y-miny)/s][(x-minx)/s] = fields[2].toFloat();
            }
        }
        tfile.close();
    }
    /*
    // get boundary
    int minx = ul[0].x,maxx = ul[0].x,miny = ul[0].y,maxy = ul[0].y;
    for(int i = 0; i < ul.length(); i++){
        minx = qMin(minx,ul[i].x);
        maxx = qMax(maxx,ul[i].x);
        miny = qMin(miny,ul[i].y);
        maxy = qMax(maxy,ul[i].y);
    }*/

    //for(int i = 0; i < ul.length(); i++)
    //    ugrid[(ul[i].y-miny)/s][(ul[i].x-minx)/s] = ul[i].h;

    // create corresponding hgt-files
    double minlon, minlat, maxlon,maxlat;
    UTM_to_latlon(33,minx,miny,&minlat,&minlon);
    UTM_to_latlon(33,maxx,maxy,&maxlat,&maxlon);
    for(int loni = floor(minlon); loni < ceil(maxlon);loni++)
        for(int lati = floor(minlat); lati < ceil(maxlat);lati++){
            FILE* f = fopen(QString(SRTM_dest_folder).append(QString("/N%1E0%2.hgt").arg(lati).arg(loni)).toLocal8Bit().data(),"wb");
            short buf;
            for(int y = SRTMresolution; y >= 0; y--){
                for(int x = 0; x <= SRTMresolution; x++){
                    double lon = 1.*loni + 1.*x/SRTMresolution;
                    double lat = 1.*lati + 1.*y/SRTMresolution;
                    double xt,yt; int uzone;
                    latlon_to_UTM(&uzone,&xt,&yt,lat,lon);
                    xt = (xt-minx)/s; yt = (yt - miny)/s;
                    CubicKernel3 kx;
                    kx.index[2] = floor(xt);
                    CubicKernel3 ky;
                    ky.index[2] = floor(yt);
                    if(kx.index[2] >= 2 && kx.index[2] < ux-3 &&
                       ky.index[2] >= 2 && ky.index[2] < uy-3){
                        double fracx = xt - floor(xt);
                        double fracy = yt - floor(yt);
                        double result = 0;
                        /*result = ugrid[int(floor(yt))][int(floor(xt))] * (1-fracx)*(1-fracy)
                                +ugrid[int(ceil (yt))][int(floor(xt))] * (1-fracx)*(  fracy)
                                +ugrid[int(floor(yt))][int(ceil (xt))] * (  fracx)*(1-fracy)
                                +ugrid[int(ceil (yt))][int(ceil (xt))] * (  fracx)*(  fracy);*/
                        kx.index[0] = kx.index[2] - 2;
                        kx.index[1] = kx.index[2] - 1;
                        kx.index[3] = kx.index[2] + 1;
                        kx.index[4] = kx.index[2] + 2;
                        kx.index[5] = kx.index[2] + 3;
                        ky.index[0] = ky.index[2] - 2;
                        ky.index[1] = ky.index[2] - 1;
                        ky.index[3] = ky.index[2] + 1;
                        ky.index[4] = ky.index[2] + 2;
                        ky.index[5] = ky.index[2] + 3;
                        for(int i = 0; i < 6; i++){
                            kx.weights[i] = Cubic_conv_kernel3(fracx+2-i);
                            ky.weights[i] = Cubic_conv_kernel3(fracy+2-i);
                        }
                        bool complete_data = true;
                        for( int x = 0; x < 6; x++)
                            for(int y = 0; y < 6; y++){
                                result += ugrid[ky.index[y]][kx.index[x]]
                                        * kx.weights[x] * ky.weights[y];
                                if(ugrid[ky.index[y]][kx.index[x]] == 0)
                                    complete_data = false;
                        }
                        buf = short(result*32.*complete_data);
                    }
                    else
                        buf = 0.;
                    buf = ((buf>>8)&0xff)+((buf << 8)&0xff00);
                    fwrite(&buf,2,1,f);
                }
            }
            fclose(f);
        }

}
double HeightData::FootpointLatitude(double y){
    double y_, alpha_, beta_, gamma_, delta_, epsilon_;
    double n = (a-b)/(a+b);
    alpha_ = ((a + b) / 2.0)*(1 + (pow(n, 2.0) / 4) + (pow(n, 4.0) / 64));
    y_ = y / alpha_;
    beta_ = (3.0 * n / 2.0) + (-27.0 * pow (n, 3.0) / 32.0)
        + (269.0 * pow (n, 5.0) / 512.0);
    gamma_ = (21.0 * pow (n, 2.0) / 16.0)
        + (-55.0 * pow (n, 4.0) / 32.0);
    delta_ = (151.0 * pow (n, 3.0) / 96.0)
        + (-417.0 * pow (n, 5.0) / 128.0);
    epsilon_ = (1097.0 * pow (n, 4.0) / 512.0);
    return y_ + (beta_ * sin (2.0 * y_))
        + (gamma_ * sin (4.0 * y_))
        + (delta_ * sin (6.0 * y_))
        + (epsilon_ * sin (8.0 * y_));
}
double HeightData::ArcLengthOfMeridian (double phi){
    double alpha, beta, gamma, delta, epsilon, n;
    double result;

    /* Precalculate n */
    n = (a - b) / (a + b);

    /* Precalculate alpha */
    alpha = ((a + b) / 2.0)
       * (1.0 + (pow (n, 2.0) / 4.0) + (pow (n, 4.0) / 64.0));

    /* Precalculate beta */
    beta = (-3.0 * n / 2.0) + (9.0 * pow (n, 3.0) / 16.0) + (-3.0 * pow (n, 5.0) / 32.0);

    /* Precalculate gamma */
    gamma = (15.0 * pow (n, 2.0) / 16.0)
        + (-15.0 * pow (n, 4.0) / 32.0);

    /* Precalculate delta */
    delta = (-35.0 * pow (n, 3.0) / 48.0)
        + (105.0 * pow (n, 5.0) / 256.0);

    /* Precalculate epsilon */
    epsilon = (315.0 * pow (n, 4.0) / 512.0);

    /* Now calculate the sum of the series and return */
    return alpha
        * (phi + (beta * sin (2.0 * phi))
        + (gamma * sin (4.0 * phi))
        + (delta * sin (6.0 * phi))
        + (epsilon * sin (8.0 * phi)));
}
void HeightData::UTM_to_latlon(int UTMcell, double x, double y, double *lat, double* lon){

        x = (x-500000.0) / UTMScaleFactor;
        y /= UTMScaleFactor;
        double phif, Nf, Nfpow, nuf2, ep2, tf, tf2, tf4, cf;
        double x1frac, x2frac, x3frac, x4frac, x5frac, x6frac, x7frac, x8frac;
        double x2poly, x3poly, x4poly, x5poly, x6poly, x7poly, x8poly;

        phif = FootpointLatitude (y);
        ep2 = (pow (a, 2.0) - pow (b, 2.0)) / pow (b, 2.0);
        cf = cos (phif);
        nuf2 = ep2 * pow (cf, 2.0);
        Nf = pow (a, 2.0) / (b * sqrt(1 + nuf2));
        Nfpow = Nf;

        /* Precalculate tf */
        tf = tan (phif);
        tf2 = tf * tf;
        tf4 = tf2 * tf2;
        x1frac = 1.0 / (Nfpow * cf);

        Nfpow *= Nf;   /* now equals Nf**2) */
        x2frac = tf / (2.0 * Nfpow);

        Nfpow *= Nf;   /* now equals Nf**3) */
        x3frac = 1.0 / (6.0 * Nfpow * cf);

        Nfpow *= Nf;   /* now equals Nf**4) */
        x4frac = tf / (24.0 * Nfpow);

        Nfpow *= Nf;   /* now equals Nf**5) */
        x5frac = 1.0 / (120.0 * Nfpow * cf);

        Nfpow *= Nf;   /* now equals Nf**6) */
        x6frac = tf / (720.0 * Nfpow);

        Nfpow *= Nf;   /* now equals Nf**7) */
        x7frac = 1.0 / (5040.0 * Nfpow * cf);

        Nfpow *= Nf;   /* now equals Nf**8) */
        x8frac = tf / (40320.0 * Nfpow);

        /* Precalculate polynomial coefficients for x**n.
           -- x**1 does not have a polynomial coefficient. */
        x2poly = -1.0 - nuf2;

        x3poly = -1.0 - 2 * tf2 - nuf2;

        x4poly = 5.0 + 3.0 * tf2 + 6.0 * nuf2 - 6.0 * tf2 * nuf2
            - 3.0 * (nuf2 *nuf2) - 9.0 * tf2 * (nuf2 * nuf2);

        x5poly = 5.0 + 28.0 * tf2 + 24.0 * tf4 + 6.0 * nuf2 + 8.0 * tf2 * nuf2;

        x6poly = -61.0 - 90.0 * tf2 - 45.0 * tf4 - 107.0 * nuf2
            + 162.0 * tf2 * nuf2;

        x7poly = -61.0 - 662.0 * tf2 - 1320.0 * tf4 - 720.0 * (tf4 * tf2);

        x8poly = 1385.0 + 3633.0 * tf2 + 4095.0 * tf4 + 1575 * (tf4 * tf2);

        /* Calculate latitude */
        *lat = (phif + x2frac * x2poly * (x * x)
            + x4frac * x4poly * pow (x, 4.0)
            + x6frac * x6poly * pow (x, 6.0)
            + x8frac * x8poly * pow (x, 8.0))/PI*180;

        /* Calculate longitude */
        *lon = ( x1frac * x
            + x3frac * x3poly * pow (x, 3.0)
            + x5frac * x5poly * pow (x, 5.0)
            + x7frac * x7poly * pow (x, 7.0))/PI*180
            + ((UTMcell-31)*6 + 3);

        return;
    }
void HeightData::latlon_to_UTM(int*UTMcell, double* x, double* y,
                               double lat, double lon){
        double phi = lat/180*PI;
        double N, nu2, ep2, t, t2, l;
        double l3coef, l4coef, l5coef, l6coef, l7coef, l8coef;
        double tmp;

        /* Precalculate ep2 */
        ep2 = (pow (a, 2.0) - pow (b, 2.0)) / pow (b, 2.0);

        /* Precalculate nu2 */
        nu2 = ep2 * pow (cos (phi), 2.0);

        /* Precalculate N */
        N = pow (a, 2.0) / (b * sqrt (1 + nu2));

        /* Precalculate t */
        t = tan(phi);
        t2 = t * t;
        tmp = (t2 * t2 * t2) - pow (t, 6.0);

        /* Precalculate l */
        *UTMcell = (lon+180)/6+1;
        l = (lon - ((*UTMcell-31)*6 + 3))/180.*PI;

        /* Precalculate coefficients for l**n in the equations below
           so a normal human being can read the expressions for easting
           and northing
           -- l**1 and l**2 have coefficients of 1.0 */
        l3coef = 1.0 - t2 + nu2;

        l4coef = 5.0 - t2 + 9 * nu2 + 4.0 * (nu2 * nu2);

        l5coef = 5.0 - 18.0 * t2 + (t2 * t2) + 14.0 * nu2
            - 58.0 * t2 * nu2;

        l6coef = 61.0 - 58.0 * t2 + (t2 * t2) + 270.0 * nu2
            - 330.0 * t2 * nu2;

        l7coef = 61.0 - 479.0 * t2 + 179.0 * (t2 * t2) - (t2 * t2 * t2);

        l8coef = 1385.0 - 3111.0 * t2 + 543.0 * (t2 * t2) - (t2 * t2 * t2);

        /* Calculate easting (x) */
        *x = N * cos (phi) * l
            + (N / 6.0 * pow (cos (phi), 3.0) * l3coef * pow (l, 3.0))
            + (N / 120.0 * pow (cos (phi), 5.0) * l5coef * pow (l, 5.0))
            + (N / 5040.0 * pow (cos (phi), 7.0) * l7coef * pow (l, 7.0));

        /* Calculate northing (y) */
        *y = ArcLengthOfMeridian (phi)
            + (t / 2.0 * N * pow (cos (phi), 2.0) * pow (l, 2.0))
            + (t / 24.0 * N * pow (cos (phi), 4.0) * l4coef * pow (l, 4.0))
            + (t / 720.0 * N * pow (cos (phi), 6.0) * l6coef * pow (l, 6.0))
            + (t / 40320.0 * N * pow (cos (phi), 8.0) * l8coef * pow (l, 8.0));

        *x = *x * UTMScaleFactor + 500000.0;
        *y = *y * UTMScaleFactor;

        return;
    }
