#include "fit.h"

FIT::FIT(char*  filename){
    FILE *file;
     FIT_UINT8 buf[8];
     FIT_CONVERT_RETURN convert_return = FIT_CONVERT_CONTINUE;
     FIT_UINT32 buf_size;
     FIT_UINT32 mesg_index = 0;
     #if defined(FIT_CONVERT_MULTI_THREAD)
        FIT_CONVERT_STATE state;
     #endif
     #if defined(FIT_CONVERT_MULTI_THREAD)
        FitConvert_Init(&state, FIT_TRUE);
     #else
        FitConvert_Init(FIT_TRUE);
     #endif

     if((file = fopen(filename, "rb")) == NULL)
     {
        return;
     }

     while(!feof(file) && (convert_return == FIT_CONVERT_CONTINUE)){
        for(buf_size=0;(buf_size < sizeof(buf)) && !feof(file); buf_size++)
           buf[buf_size] = (FIT_UINT8)getc(file);

        do{
           #if defined(FIT_CONVERT_MULTI_THREAD)
              convert_return = FitConvert_Read(&state, buf, buf_size);
           #else
              convert_return = FitConvert_Read(buf, buf_size);
           #endif

           switch (convert_return){
              case FIT_CONVERT_MESSAGE_AVAILABLE:{
                 #if defined(FIT_CONVERT_MULTI_THREAD)
                    const FIT_UINT8 *mesg = FitConvert_GetMessageData(&state);
                    FIT_UINT16 mesg_num = FitConvert_GetMessageNumber(&state);
                 #else
                    const FIT_UINT8 *mesg = FitConvert_GetMessageData();
                    FIT_UINT16 mesg_num = FitConvert_GetMessageNumber();
                 #endif


                if(mesg_num == FIT_MESG_NUM_RECORD){
                    const FIT_RECORD_MESG *record = (FIT_RECORD_MESG *) mesg;
                    add_point(
                        record->position_long,
                        record->position_lat,
                        record->altitude,
                        record->timestamp);
                }
             }
             default:
                break;
          }
       } while (convert_return == FIT_CONVERT_MESSAGE_AVAILABLE);
    }

     fclose(file);
}
void FIT::add_point(double lon, double lat, double h, long int time){
    gpxlist* g;
    if(l != NULL){
        (*l)->prev->next = new gpxlist;
        g = (*l)->prev->next;
    }
    else{
        l = new gpxlist*;
        *l = new gpxlist;
        g = *l;
        (*l)->prev = g;
    }
    g->prev = (*l)->prev;
    (*l)->prev = g;
    g->next = NULL;
    g->d = 0;
    g->lat = lat;
    g->lon = lon;
    g->h = h;
    g->time = time;
}
double** FIT::get_complete(long int* n){
    *n = 0;
    double** result;
    if(l != NULL){
        gpxlist *g = *l;
        while(g != NULL){
            (*n)++;
            g = g->next;
        }

        g = *l;
        result = new double*[5];
        for(int i = 0; i < 5; i++)
            result[i] = new double[*n];
        for(int i = 0; i < *n; i++){
            result[0][i] = g->d;
            result[1][i] = g->h;
            result[2][i] = g->lat;
            result[3][i] = g->lon;
            result[4][i] = g->time;
            g = g->next;
        }
    }
    else
        result = NULL;

    return result;
}
