﻿#include <stdio.h>
#include <stdlib.h>
#include <QString>
#include <QMessageBox>
#include "MathExt.h"
#include "FIT_converter/fit_convert.h"

class gpxlist{
public:
    gpxlist(double d, double h, double lat, double lon, double time);
    gpxlist(double d, double h, double lat, double lon, double time,
            double bpm, double Ws);
    void add_distance_to(gpxlist nb);
	double d,h,lat,lon;
	long int time;
    double bpm;
    double W;
    static const int R0 = 6371;			//Erdradius
};

class gpx{
public:
	gpx(char* filename);
	~gpx();
	void read_in();						//Startet Einlesen der Datei filename
	void setfilename();
	double** get_d_h_t(long int* n);	//Distanz[][0],Hoehe[][1], UnixZeit[][2] als Array
	double** get_KOO(long int* n);		//Breite[][0],Laenge[][1] als Array
	double** get_complete(long int* n);	//Distanz[][0], Hoehe[][1], Breite[][2], Laenge[][3], UnixZeit[][4] als Array
    int get_typ();
    //void* get_complete_List();			//Liste{double d,h,lon,lat; Liste *next, *prev}
private:
    void from_gpx();
    void from_fit();
    void remove_stops_teleportations(); // deletes data withzero velocity or jumping position
    void calc_distance();
    void relax_heights(int repetitions);// smooths integer data artifact steps
    void determin_typ();                // running, skiing or cycling
    void correct_bpm();
    QList<gpxlist> l;   				//Hauptliste, um die sich alles dreht
	char* file;							//behandelte Datei
    int typ;                            //1: cycling, 2: skiing, 3 running

	/*Arbeiten mit der Datenliste l*/
	void add_point(double lon, double lat, double h, long int time); 
										//fuegt Punkt zu l hinzu
    void add_point(double lon, double lat, double h, long int time,
                   double bpm, double Ws);
                                        //fuegt Punkt zu l hinzu
	double distance(double lat1, double lon1, double lat2, double lon2);
										//berechnet Distanz auf l	
	/*XML-Hilfsfunktionen*/
	void replace_quotation(char* a);	//Ersetzt " durch '
    void extract_attribute(const char* attr, char* src, double* result);
    void extract_element(const char* elem, char* src, double* result);
	void extract_time(char* src, long int* unix_time);
    double v(int i);                    // returns velocity from i-1 to i
};
