﻿#include "mainwindow.h"
#include "ui_mainwindow.h"

KOO* get_KOO_helper(qint64 id, void* osm){
    OSM* o = (OSM*) osm;
    return o->search(id,o->get_first_KOO());
}

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow){
    autoload_setting();
    ui->setupUi(this);
    centralWidget()->setLayout(ui->verticalLayout);
    showMaximized();
    init();
    centralWidget()->setMouseTracking(true);
    ui->Map->setMouseTracking(true);
    ui->profil->setMouseTracking(true);
    ui->profil->settings(&(c.PS));
    setMouseTracking(true);
    statusBar()->addWidget(statusLeft, 1);
    statusBar()->addWidget(statusMiddle, 2);
    connect(ui->actionClose,SIGNAL(triggered()),this,SLOT(close()));
    connect(ui->actionSpecify_SRTM3_data_folder,SIGNAL(triggered()),this,SLOT(set_SRTM3_folder()));
    connect(ui->actionLoad_btp,SIGNAL(triggered()),this,SLOT(load_btp()));
    connect(ui->actionSave_btp,SIGNAL(triggered()),this,SLOT(save_btp()));
    connect(ui->actionRead_osm,SIGNAL(triggered()),this,SLOT(read_osm()));
    connect(ui->actionBtp_startup_file,SIGNAL(triggered()),this,SLOT(set_start_btp()));
    connect(ui->profil,SIGNAL(mousex(double)),this,SLOT(profilinfo(double)));
    connect(ui->actionSTRONG_settings,SIGNAL(triggered()),this,SLOT(STRONG_settings()));
    connect(ui->actionClimbs,SIGNAL(triggered()),this,SLOT(AnalyseClimbs()));
    connect(ui->actionToggle_Climblayer,SIGNAL(triggered()),this,SLOT(toggle_Climblayer()));
    connect(ui->actionToggle_STRONGlayer,SIGNAL(triggered()),this,SLOT(toggle_STRONGlayer()));
    connect(ui->actionLoad_Climblayer,SIGNAL(triggered()),this,SLOT(load_Climblayer()));
    connect(ui->actionCreate_STRONGlayer,SIGNAL(triggered()),this,SLOT(create_STRONGlayer()));
    connect(ui->actionLoad_STRONGlayer,SIGNAL(triggered()),this,SLOT(load_STRONGlayer()));
    connect(ui->actionSave_STRONGlayer,SIGNAL(triggered()),this,SLOT(save_STRONGlayer()));
    connect(ui->actionGenerateMap,SIGNAL(triggered()),this,SLOT(generate_Map()));
    connect(ui->actionInvert_height_data,SIGNAL(triggered()),this,SLOT(invert_Hm()));
    connect(ui->actionNormalize_height_data,SIGNAL(triggered()),this,SLOT(normalize_Hm()));
    connect(ui->actionSave_gpx,SIGNAL(triggered()),SLOT(save_gpx()));
    connect(ui->actionSave_Profil_as_png,SIGNAL(triggered()),SLOT(save_profile()));
    connect(ui->actionSettings,SIGNAL(triggered()),SLOT(profil_settings()));
    connect(ui->actionOn_off,SIGNAL(triggered()),this,SLOT(toggle_poweranalysis()));
    connect(ui->actionSettings_2,SIGNAL(triggered()),this,SLOT(map_settings()));
    connect(PA,SIGNAL(recalced()),this,SLOT(update_profil()));
    connect(ui->profil,SIGNAL(clicked(double)),this,SLOT(center_track(double)));
    connect(ui->profil,SIGNAL(call_zoom_repaint(double,double)),this,SLOT(zoom_profil(double,double)));
    connect(ui->profil,SIGNAL(call_fullview()),this,SLOT(update_profil()));
    connect(ui->actionShow_Power,SIGNAL(triggered()),this,SLOT(toggle_showpower()));
    connect(ui->actionShow_Speed_in_plot,SIGNAL(triggered()),this,SLOT(toggle_showspeed()));
    connect(ui->actionShow_bpm_in_plot,SIGNAL(triggered()),this,SLOT(toggle_showbpm()));
    connect(ui->actionAnalyse_gpx,SIGNAL(triggered()),this,SLOT(analyse_gpx()));
    connect(ui->actionLoad_STRONG_calculation,SIGNAL(triggered()),this,SLOT(load_STRONGcalc()));
    connect(ui->actionSave_STRONG_calculation,SIGNAL(triggered()),this,SLOT(save_STRONGcalc()));
    connect(ui->actionGenerate_tiles,SIGNAL(triggered()),this,SLOT(generate_tiles()));
    connect(ui->actionSplit_pbf,SIGNAL(triggered()),this,SLOT(split_europe_pbf()));
    connect(ui->actionCorrect_hgt_Files,SIGNAL(triggered()),this,SLOT(correct_hgt()));
    connect(ui->actionRead_osm_2,SIGNAL(triggered()),this,SLOT(read_europe()));
    connect(ui->actionGenerate_climbdata,SIGNAL(triggered()),this,SLOT(CA_europe()));
    connect(ui->actionGenerate_STRONG_layer,SIGNAL(triggered()),this,SLOT(STRONG_europe()));
    connect(ui->actionExtractZoom12,SIGNAL(triggered()),this,SLOT(zoom14_collection()));
    connect(ui->actionsave_binary,SIGNAL(triggered()),this,SLOT(save_track_binary()));
    connect(ui->actionSummitranking_split,SIGNAL(triggered()),this,SLOT(summitranking_split()));
    connect(ui->actionSummitranking_calc,SIGNAL(triggered()),this,SLOT(summitranking_calc()));
    connect(ui->actionSummitrankung_merge,SIGNAL(triggered()),this,SLOT(summitranking_collect()));
    connect(ui->actionSave_btr,SIGNAL(triggered()),this,SLOT(save_btr()));
    connect(ui->actionLoad_btr,SIGNAL(triggered()),this,SLOT(load_btr()));
    connect(ui->action_swapHmd,SIGNAL(triggered()),this,SLOT(swap_Hm_d()));
    connect(ui->actionShow3D,SIGNAL(triggered()),this,SLOT(show3D()));
    connect(ui->actionData_to_clipcoard,SIGNAL(triggered()),ui->profil,SLOT(data_to_clipboard()));
    connect(ui->actionPAData_to_clipboard,SIGNAL(triggered()),PA,SLOT(data_to_clipboard()));
    connect(ui->actionImport_gpx,SIGNAL(triggered()),this,SLOT(import_gpx()));
    connect(ui->actionSave_binaryPlus,SIGNAL(triggered()),this,SLOT(save_track_binaryPlus()));
    connect(ui->actionCurrent_Segment_to_gpx,SIGNAL(triggered()),SLOT(save_segment_gpx()));
    connect(ui->actionBinary_binary_plus,SIGNAL(triggered()),this,SLOT(convert_binary_to_binaryPlus()));
    connect(ui->actionSites_along_track_to_clipboard,SIGNAL(triggered()),this,SLOT(list_sites_to_clipboard()));
    connect(ui->actionTotal_network_length_to_clipboard,SIGNAL(triggered()),this,SLOT(network_length_to_clipboard()));
    connect(ui->actionSRTM1_data_folder,SIGNAL(triggered()),this,SLOT(set_SRTM1_folder()));
    connect(ui->actionSRTM018,SIGNAL(triggered()),this,SLOT(set_SRTM018_folder()));
    connect(ui->actionSRTM066_data_folde,SIGNAL(triggered()),this,SLOT(set_SRTM066_folder()));
    connect(ui->actionDGM2_to_SRTM018,SIGNAL(triggered()),this,SLOT(DGM2_to_SRTM018()));
    connect(ui->actionDGM20_to_SRTM066,SIGNAL(triggered()),this,SLOT(DGM20_to_SRTM066()));
    connect(ui->actionToggle_Hike_Bike,SIGNAL(triggered()),this,SLOT(toggle_HikeBike()));
    connect(ui->actionCurrent_Segment_climb_analysis,SIGNAL(triggered()),this,SLOT(climb_analysis_current_segment()));
    connect(ui->actionFit_Training_diary,SIGNAL(triggered()),this,SLOT(training_diary()));
    /*for(int i = 2706; i <= 2862; i++){
        QDir destdir("D:\\ClimbProject\\Tiles\\13_Selection");
        destdir.mkdir(QString("%1").arg(i));
        destdir.cd(QString("%1").arg(i));
        for(int j = 4194; j < 4498; j++){
            QFile f(QString("D:\\ClimbProject\\Tiles\\13\\%1\\%2.png").arg(i).arg(j));
            f.copy(destdir.absoluteFilePath(QString("%1.png").arg(j)));
        }
    }*/

    /*Track *tracks[8];
    Track* trackresult;
    bool errors[8];
    tracks[0] = new Track("C:\\Users\\User\\Desktop\\OSM\\salesman\\hesenbachN.btr",&get_KOO_helper,(void*)osm);
    tracks[1] = new Track("C:\\Users\\User\\Desktop\\OSM\\salesman\\hesenbachS.btr",&get_KOO_helper,(void*)osm);
    tracks[2] = new Track("C:\\Users\\User\\Desktop\\OSM\\salesman\\0hinterbaerenburg.btr",&get_KOO_helper,(void*)osm);
    tracks[3] = new Track("C:\\Users\\User\\Desktop\\OSM\\salesman\\0Hirschstange.btr",&get_KOO_helper,(void*)osm);
    tracks[4] = new Track("C:\\Users\\User\\Desktop\\OSM\\salesman\\0langgrundweg.btr",&get_KOO_helper,(void*)osm);
    tracks[5] = new Track("C:\\Users\\User\\Desktop\\OSM\\salesman\\0vorderbaerenburger.btr",&get_KOO_helper,(void*)osm);
    tracks[6] = new Track("C:\\Users\\User\\Desktop\\OSM\\salesman\\bobbahn.btr",&get_KOO_helper,(void*)osm);
    tracks[7] = new Track("C:\\Users\\User\\Desktop\\OSM\\salesman\\eisenstrasse.btr",&get_KOO_helper,(void*)osm);

    if(r->salesman(kold,knew,c.maxtype,c.mintype,osm,&(tracks[0]),8,&trackresult,errors)){
        ct = trackresult;
        update_map_track();
        update_profil();
    }*/
    /*analyse_gpx("D:\\Elbpitze.de\\2019\\ES19.gpx");
    double** KOOdata = ct->get_KOOa();
    int count = ct->get_KOOa_length();
    int* index = importance(count,KOOdata[0],1,KOOdata[1],cos(50.83/180*M_PI));
    QString cbs;
    for(int i = 0; i < count; i++){
        cbs.append(QString("%1\t%2\t%3\n").arg(KOOdata[1][i]*cos(50.83/180*M_PI)).arg(KOOdata[0][i]).arg(index[i]));
    }
    double** dhdata = ct->get_d_h_array();
    int count = ct->get_d_h_length();
    int* index = importance(count,dhdata[0],1,dhdata[1],1000);
    QString cbs;
    for(int i = 0; i < count; i++){
        cbs.append(QString("%1\t%2\t%3\n").arg(dhdata[0][i]).arg(dhdata[1][i]).arg(index[i]));
    }
    QApplication::clipboard()->setText(cbs);*/

    /*double b1 = 51.032320;
    double l1 = 13.865695;
    double b2 = 51.032433;
    double l2 = 13.876285;
    QString cbs;
    HeightData hd;
    hd.set_SRTM3_folder(c.SRTM3folder);
    for(double a = 0; a <= 0.4; a += 0.001){
        double l = a*l2 + (1-a)*l1;
        double b = a*b1 + (1-a)*b1;
        cbs.append(QString("%1\t%2\t%3\t%4\t%5\n")
                   .arg(b).arg(l)
                   .arg(distance(b1,l1,b,l))
                   .arg(hd.height(l,b,NULL,0))
                   .arg(hd.simple_height(l,b)));
    }
    QApplication::clipboard()->setText(cbs);*/
    //DOM_to_SRTM();
    //analyse_gpx("C:\\Users\\User\\Sport\\Strecken\\2020-09-08-07-00-08.fit");
    //analyse_fit();
    //read_osm("C:\\Users\\User\\Desktop\\FEhler\\9-281-153.btp.osm");
}

MainWindow::~MainWindow(){
    if(autosave) autosave_setting();
    if(btp_modified){
        QMessageBox::StandardButton reply;
        reply = QMessageBox::question(this, "Data base has been edited", "Do you want to save btp-file?",
                                      QMessageBox::Yes|QMessageBox::No);
        if (reply == QMessageBox::Yes) {
            QString filename = QFileDialog().getSaveFileName(this,"save BTP data","","BergTourenPlaner data (*.btp)");
            if(!filename.isEmpty())
                save_btp(filename,osm->getminlat(),osm->getmaxlat(),
                                  osm->getminlon(),osm->getmaxlon());
        }
    }
    delete map;
    delete osm;
    delete hd;
    delete ui;
}
void MainWindow::closeEvent(QCloseEvent *){
    PA->close();
}

void MainWindow::resizeEvent ( QResizeEvent * event ){
    /*QPixmap prev(event->size().width()-10,event->size().height()*0.8-10);
    prev.fill(Qt::black);
    QRectF Rdest(0,0,event->size().width()-10,event->size().height()*0.8-10);
    QRectF Rsrc(0,0,map->getwidth(),map->getheight());
    QPainter painter(&prev);
    painter.drawPixmap(Rdest,*cmap,Rsrc);
    ui->Map->setPixmap(prev);
    ui->Map->repaint();*/
    //QSize sold = event->oldSize();
    //QSize snew = event->size();
    //if(sold.width()>0 && sold.height() > 0)
        //if(qAbs(sold.width()-snew.width())>10 || qAbs(sold.height()-snew.height()) > 0)
        //not at programm start

}
void MainWindow::keyPressEvent(QKeyEvent *event){
    switch(event->key()){
        case Qt::Key_Right:
            zoom(1. , 0.5,   0); break;
        case Qt::Key_Left:
            zoom(1. ,-0.5,   0); break;
        case Qt::Key_Up:
            zoom(1. ,   0, 0.5); break;
        case Qt::Key_Down:
            zoom(1. ,   0,-0.5); break;
        case Qt::Key_Plus:
            zoom(0.5,   0,   0); break;
        case Qt::Key_Minus:
            zoom(2. ,   0,   0); break;
        case Qt::Key_Escape:
            if(c.input == routeshort ||
               c.input == routeflat)
                    reset_track();
            else
                emit stop_STRONG();
            break;
        case Qt::Key_Delete:
            reset_track();
            break;
        case Qt::Key_Backspace:
            if(QApplication::keyboardModifiers() == Qt::ControlModifier)
                delete_to_cross(10);
            else
                delete_to_cross(1);
            break;
        case 94:
            set_mintype(0);
            set_maxtype(0);
            break;
        case Qt::Key_1:
            if(QApplication::keyboardModifiers() == Qt::ControlModifier)
                set_mintype(1);
            else
                set_maxtype(1);
            break;
        case Qt::Key_2:
            if(QApplication::keyboardModifiers() == Qt::ControlModifier)
                set_mintype(2);
            else
                set_maxtype(2);
            break;
        case Qt::Key_3:
            if(QApplication::keyboardModifiers() == Qt::ControlModifier)
                set_mintype(3);
            else
                set_maxtype(3);
            break;
        case Qt::Key_4:
            if(QApplication::keyboardModifiers() == Qt::ControlModifier)
                set_mintype(4);
            else
                set_maxtype(4);
            break;
        case Qt::Key_5:
            if(QApplication::keyboardModifiers() && Qt::ControlModifier)
                set_mintype(5);
            else
                set_maxtype(5);
            break;
        case Qt::Key_6:
            if(QApplication::keyboardModifiers() && Qt::ControlModifier)
                set_mintype(6);
            else
                set_maxtype(6);
            break;
        case Qt::Key_7:
            if(QApplication::keyboardModifiers() && Qt::ControlModifier)
                set_mintype(7);
            else
                set_maxtype(7);
            break;
        case Qt::Key_8:
            if(QApplication::keyboardModifiers() && Qt::ControlModifier)
                set_mintype(8);
            else
                set_maxtype(8);
            break;
        case Qt::Key_9:
            if(QApplication::keyboardModifiers() && Qt::ControlModifier)
                set_mintype(9);
            else
                set_maxtype(9);
            break;
        case Qt::Key_0:
            if(QApplication::keyboardModifiers() && Qt::ControlModifier)
                set_mintype(10);
            else
                set_maxtype(10);
            break;
        case Qt::Key_PageUp:
            if(QApplication::keyboardModifiers() && Qt::ControlModifier)
               selectSTRONG(fw,10);
            else
               selectSTRONG(fw,1);
            break;
        case Qt::Key_PageDown:
            if(QApplication::keyboardModifiers() && Qt::ControlModifier)
               selectSTRONG(bw,10);
            else
               selectSTRONG(bw,1);
            break;
        case Qt::Key_A:
            if(QApplication::keyboardModifiers() && Qt::ControlModifier)
                analyse_gpx();
            else
                set_routingmode(salesman);  break;
        case Qt::Key_B:
            set_routingmode(routemountain);  break;
        case Qt::Key_C:
            if(QApplication::keyboardModifiers() && Qt::ControlModifier)
                coordinate_to_clipbard();
            else
                set_routingmode(routeclimb);  break;
            break;
        case Qt::Key_E:
            set_routingmode(editdata);  break;
        case Qt::Key_F:
            set_routingmode(routeflat);  break;
        case Qt::Key_G:
            got_to_latlon();  break;
        case Qt::Key_K:
            set_routingmode(routeshort);  break;
        case Qt::Key_M:
            use_marked_ways = !use_marked_ways;
            set_routingmode(c.input);
            break;
        case Qt::Key_L:
            set_routingmode(selectlayer);  break;
        case Qt::Key_N:
            toggle_preview(); break;
        case Qt::Key_R:
            apply_traffic_restrictions = !apply_traffic_restrictions;
            set_routingmode(c.input);
            break;
        case Qt::Key_S:
            if(QApplication::keyboardModifiers() && Qt::ControlModifier)
                climb_analysis_current_segment();
            else
                set_routingmode(routeSTRONG);  break;
        case Qt::Key_T:{
            status2 = "preapring least time routing ...";
            update_statusbar();
            PowerAnalysis PAT(&(c.PA));
            osm->refresh_time(osm->get_first_KOO(),PAT.neighbour_to_time,
                              (void*)&PAT);
            set_routingmode(routetime); } break;
        case Qt::Key_Z:
            undo();
            break;
        case Qt::Key_Y:
            redo();
            break;
        case Qt::Key_Return:
            enter();break;
        case Qt::Key_F1:
            generate_Map();break;
        case Qt::Key_F5:
            hd->set_SRTM3_folder(c.SRTM3folder);
            c.DEM_level = 0;
            update_map_raw();
            break;
        case Qt::Key_F6:
            hd->set_SRTM1_folder(c.SRTM1folder);
            c.DEM_level = 1;
            update_map_raw();
            break;
        case Qt::Key_F7:
            hd->set_SRTM066_folder(c.SRTM066folder);
            c.DEM_level = 2;
            update_map_raw();
            break;
        case Qt::Key_F8:
            hd->set_SRTM018_folder(c.SRTM018folder);
            c.DEM_level = 3;
            update_map_raw();
            break;
    }
}
void MainWindow::zoom(double zoomfactor,double dlonfactor, double dlatfactor){
    map->scale(zoomfactor,dlonfactor,dlatfactor);
    update_map_raw();
}
void MainWindow::init(){
    apply_traffic_restrictions = false;
    use_marked_ways = false;
    btp_modified = false;
    selected_way = NULL;
    kold = knew = NULL;
    kl_i_from = kl_i_to = -1;
    STRONGstate = readytotrace = traceback = 0;
    autosave = 1;
    SL = NULL;
    CL = NULL;
    SLN = SLc = 0;
    ct = new Track();
    lrt = new Track();
    cmap = new QPixmap;
    osm = new OSM;
    osm->load(c.start_btp);
    hd = new HeightData();
    switch(c.DEM_level){
        case 0: hd->set_SRTM3_folder(c.SRTM3folder); break;
        case 1: hd->set_SRTM1_folder(c.SRTM1folder); break;
        case 2: hd->set_SRTM066_folder(c.SRTM066folder); break;
        case 3: hd->set_SRTM018_folder(c.SRTM018folder); break;
    }
    map = ui->Map;
    map->set_data(hd,osm);
    map->settings(&(c.MS));
    map->init_map(1920,1080);
    r = new Routing(osm);
    UR = new UndoRedo;
    PA = new PowerAnalysis(&(c.PA));
    PA->show();
    statusLeft = new QLabel("coordinates", this);
    statusLeft->setFrameStyle(QFrame::Panel | QFrame::Sunken);
    statusMiddle = new QLabel("further information", this);
    statusMiddle->setFrameStyle(QFrame::Panel | QFrame::Sunken);
}
void MainWindow::show3D(){
    Terrain *t = new Terrain(osm,&ct,500,300,&c);
    double lat = (map->getmaxlat()+map->getminlat())/2;
    double lon = (map->getmaxlon()+map->getminlon())/2;
    t->setpos(lat,lon,map->XY_to_height(map->getwidth()/2,map->getheight()/2)+500,0,0,500);
    //t->load_config();
    t->retexture();
    t->show();
}

void MainWindow::autoload_setting(){
    QString filename = QCoreApplication::applicationDirPath();
    filename.append("/settings.stg");
    FILE* f = fopen(filename.toLocal8Bit().data(),"rb");
    if(f != NULL){
        fread(&c,sizeof(config),1,f);
        fclose(f);
    }
    else
        init_config();
}
void MainWindow::autosave_setting(){
    QString filename = QCoreApplication::applicationDirPath();
    filename.append("/settings.stg");
    FILE* f = fopen(filename.toLocal8Bit().data(),"wb");
    fwrite(&c,sizeof(config),1,f);
    fclose(f);
}
void MainWindow::init_config(){
     c.mintype= 0;
     c.maxtype= 4;
     c.SRTM3folder[0] = '\0';
     c.SRTM1folder[0] = '\0';
     c.SRTM066folder[0] = '\0';
     c.SRTM018folder[0] = '\0';
     c.DEM_level = 0;
     c.start_btp[0] = '\0';
     BTP3setups(&(c.sconfig),&(c.mconfig),&(c.cconfig)).init();
     BTP3setups(&(c.CA)).init();
     BTP3setups(&(c.PS)).init();
     BTP3setups(&(c.MS)).init();
     c.input = routeshort;
     c.drawSTRONGlayer = 1;
     c.drawRoute = 0;
     c.drawClimblayer = 1;
     c.plotpower = 1;
     c.plotspeed = 1;
     c.plotbpm = 1;
     PowerAnalysis().set_default(&(c.PA));
}
void MainWindow::update_map_raw(){
    QString status2keep = status2;
    status2 = "Map is rendering...";
    update_statusbar();

    climblayer* clt = NULL;
    if(CL != NULL && c.drawClimblayer)  clt = CL;
    STRONGlayer* slt = NULL;
    if(SL != NULL && c.drawSTRONGlayer)  slt = SL;

    map->draw_map(slt,clt,NULL,1);

    update_map_track();
    status2 = status2keep;
    update_statusbar();
}
void MainWindow::update_map_track(){
    map->draw_elements(ct,kold,knew,selected_way);
}
void MainWindow::update_map_MovObj(Way* w){
    QBrush brush(Qt::red);
    if(dstate != nonedot){
        if(dstate == crossdot)
            brush.setColor(Qt::yellow);
        if(dstate == crossdotmarked)
            brush.setColor(Qt::black);
        map->show_elements(w,xdot,ydot,brush);
    }
    else
        map->show_elements(w,-100,-100,brush);

}
void MainWindow::update_profil(){
    if(ct != NULL){
        double hm = ct->get_height_meters();
        double d = ct->get_length();
        if(ct == lrt && PA->isVisible() && PA->isready()){
            ui->profil->set_labels(QString("%1 km  %2 Hm  %3 Hm/km  %4 km/h  %5 W  NP %6 W  %7 bpm TRIMP %8")
                                   .arg(d,0,'f',2)
                                   .arg(hm,0,'f',0)
                                   .arg(hm/d,0,'f',1)
                                   .arg(PA->get_v(),0,'f',1)
                                   .arg(PA->get_P(),0,'f',0)
                                   .arg(PA->get_NP(),0,'f',0)
                                   .arg(PA->get_bpm(),0,'f',0)
                                   .arg(PA->get_TRIMP(),0,'f',0),
                               "d [km]","h [m]");

        }
        else
            ui->profil->set_labels(QString("%1 km  %2 Hm  %3 Hm/km")
                                   .arg(d,0,'f',2)
                                   .arg(hm,0,'f',0)
                                   .arg(hm/d,0,'f',1),
                               "d [km]","h [m]");
        double **dt = NULL,**dt1 = NULL,**dt2 = NULL,**dt3 = NULL;
        int tc=0,tc1=0,tc2=0,tc3=0;
        dt = ct->get_d_h_array();
        tc = ct->get_d_h_length();
        if(c.plotspeed && ct == lrt && PA->isVisible() && PA->isready()){
            dt1 = PA->get_vdata();
            tc1 = PA->get_datacount();
        }
        if(c.plotpower && ct == lrt && PA->isVisible() && PA->isready()){
            dt2 = PA->get_Pdata();
            tc2 = PA->get_datacount();
        }
        if(c.plotbpm && ct == lrt && PA->isVisible() && PA->isready()){
            dt3 = PA->get_bpmdata();
            tc3 = PA->get_datacount();
        }
        ui->profil->set_data(dt,tc,dt1,tc1,dt2,tc2,dt3,tc3);
    }
}
void MainWindow::drawCross(QPainter *p){
    p->setPen(Qt::NoPen);
    p->setBrush(QBrush(Qt::green));
    if(kold != NULL)
        p->drawEllipse(map->lon_to_x(kold->lon)-5,
                       map->lat_to_y(kold->lat)-5,
                       11,11);
    if(knew != NULL)
        p->drawEllipse(map->lon_to_x(knew->lon)-5,
                       map->lat_to_y(knew->lat)-5,
                       11,11);
}
void MainWindow::drawRoute(QPainter *p){
    if(ct != NULL){
        // draw line
        p->setPen(QPen(QBrush(c.MS.trackcolor),map->zoomsize(c.MS.trackwidth)));
        map->draw_line(p,ct);
    }
}
void MainWindow::set_SRTM3_folder(){
    QString filename = QFileDialog::getExistingDirectory(this,"select SRTM3 data directory");
    strcpy(c.SRTM3folder,filename.toLocal8Bit().data());
    hd->set_SRTM3_folder(c.SRTM3folder);
    c.DEM_level = 0;
    update_map_raw();
}
void MainWindow::set_SRTM1_folder(){
    QString filename = QFileDialog::getExistingDirectory(this,"select SRTM1 data directory");
    strcpy(c.SRTM1folder,filename.toLocal8Bit().data());
    hd->set_SRTM1_folder(c.SRTM1folder);
    c.DEM_level = 1;
    update_map_raw();
}
void MainWindow::set_SRTM066_folder(){
    QString filename = QFileDialog::getExistingDirectory(this,"select SRTM066 data directory");
    strcpy(c.SRTM066folder,filename.toLocal8Bit().data());
    hd->set_SRTM066_folder(c.SRTM066folder);
    c.DEM_level = 2;
    update_map_raw();
}
void MainWindow::set_SRTM018_folder(){
    QString filename = QFileDialog::getExistingDirectory(this,"select SRTM018 data directory");
    strcpy(c.SRTM018folder,filename.toLocal8Bit().data());
    hd->set_SRTM018_folder(c.SRTM018folder);
    c.DEM_level = 3;
    update_map_raw();
}
void MainWindow::DGM2_to_SRTM018(){
    QString dirname = QFileDialog::getExistingDirectory(this,"select DGM data directory");
    hd->DOM_to_SRTM(dirname,dirname,2,20000);
}
void MainWindow::DGM20_to_SRTM066(){
    QString dirname = QFileDialog::getExistingDirectory(this,"select DGM data directory");
    hd->DOM_to_SRTM(dirname,dirname,20,5500);
}
void MainWindow::mousePressEvent(QMouseEvent *event){
    if(event->button()==Qt::LeftButton && !traceback){
        xold = event->x()-centralWidget()->x();
        yold = event->y()-centralWidget()->y();
        // drag drop track modification might be activated
        if(	(c.input == routeshort || c.input == routeflat || c.input == routetime)
            && ct->found_anchors(map->Y_to_lat(yold),map->X_to_lon(xold),
                                 map->scale()*5,&kl_i_from,&kl_i_to)){
            // track was clicked at marked cross position, preparing for drag&drop
            if(c.input == routeshort){
                if(kl_i_from >= 0)
                    r->Dijkstra(ct->get_KOO(kl_i_from),NULL,c.maxtype,c.mintype,osm,0,r->get_d,
                                use_marked_ways,pf_short*apply_traffic_restrictions);
                if(kl_i_to >= 0)
                    r->Dijkstra(ct->get_KOO(kl_i_to),NULL,c.maxtype,c.mintype,osm,1,r->get_d,
                                use_marked_ways,pf_short*apply_traffic_restrictions);
            }
            if(c.input == routeflat){
                if(kl_i_from >= 0)
                    r->Dijkstra(ct->get_KOO(kl_i_from),NULL,c.maxtype,c.mintype,osm,0,r->get_hm,
                                use_marked_ways,pf_flat*apply_traffic_restrictions);
                if(kl_i_to >= 0)
                    r->Dijkstra(ct->get_KOO(kl_i_to),NULL,c.maxtype,c.mintype,osm,1,r->get_hm,
                                use_marked_ways,pf_flat*apply_traffic_restrictions);
            }
            if(c.input == routetime){
                if(kl_i_from >= 0)
                    r->Dijkstra(ct->get_KOO(kl_i_from),NULL,c.maxtype,c.mintype,osm,0,r->get_t,
                                use_marked_ways,pf_time*apply_traffic_restrictions);
                if(kl_i_to >= 0)
                    r->Dijkstra(ct->get_KOO(kl_i_to),NULL,c.maxtype,c.mintype,osm,1,r->get_t,
                                use_marked_ways,pf_time*apply_traffic_restrictions);
            }
            readytotrace = traceback = 1;
        }
    }
}
void MainWindow::mouseReleaseEvent(QMouseEvent *event){
    x = event->x()-centralWidget()->x();
    y = event->y()-centralWidget()->y();
    if(event->button()==Qt::LeftButton){
        if(traceback && (x != xold || y != yold))
            accept_ct();
        else{
            if(x == xold || y == yold){
                if(c.input == editdata){
                    // map element ist going to be edited
                    kold = NULL;
                    knew = NULL;
                    selected_way = osm->select_Way(map->Y_to_lat(y),map->X_to_lon(x));
                    if(selected_way != NULL){
                        status2 = QString("Way %1 selected, typ: %2")
                                    .arg(selected_way->id)
                                    .arg((int)selected_way->type);
                        update_statusbar();
                        update_map_track();
                    }
                }
                else{
                    // cross was was clicked
                    if(		(dstate == crossdot || dstate == crossdotmarked)
                        &&  kdot != NULL){
                        // cross on ct was clicked
                        ct->toggle_marker(kdot);
                        traceback = 0;
                        readytotrace = 0;
                        update_map_track();
                    }
                    else{
                        // cross aside track was clicked
                        if(STRONGstate == 1){
                            status2 = "STRONG calculation still running. ESC to quit.";
                            update_statusbar();
                            return;
                        }
                        if(STRONGstate == 2)
                            acceptSTRONG();

                        KOO* k = osm->get_first_KOO();
                        float d = 1e10;
                        osm->select_cross(map->Y_to_lat(y),map->X_to_lon(x),
                                          c.mintype,c.maxtype,&k,&d,k);
                        kold = knew;
                        knew = k;
                        if(event->modifiers()==Qt::ControlModifier){
                            if(knew == NULL || kold == knew || d > 0.1){
                                knew = new KOO(-1);
                                knew->lat = map->Y_to_lat(y);
                                knew->lon = map->X_to_lon(x);
                            }
                            if(kold != NULL)
                                route_airline();
                            else
                                update_map_track();
                        }
                        else{
                            if(knew != NULL  && kold != NULL && kold != knew
                               && kold->cd != NULL){
                                // start and end are known, algorithms are
                                //allowed to work
                                if(c.input == routeshort)	route_short();
                                if(c.input == routeflat)	route_flat();
                                if(c.input == routetime)	route_time();
                                if(c.input == salesman)     route_salesman();
                                if(c.input == routeSTRONG
                                 ||c.input == routeclimb
                                 ||c.input == routemountain)
                                                            route_STRONG();
                            }
                            else
                                update_map_track();
                        }
                        // routing is finished, reset the old selected cross
                    }
                }
            }
            else{
                if(event->modifiers()==Qt::ControlModifier){
                    /*zoom box*/
                    zoom((1.*abs(x-xold)/map->size().width()+1.*abs(y-yold)/map->size().height())/2.,
                         1.*((x+xold)/2.-map->size().width()/2.)/map->size().width(),
                         1.*(map->size().height()/2.-(yold+y)/2.)/map->size().height());
                }
                else{
                    /*move map*/
                    zoom(1.,1.*(xold-x)/map->size().width(),1.*(y-yold)/map->size().height());
                }
            }
        }
    }
}
void MainWindow::mouseMoveEvent(QMouseEvent *event){
    this->setFocus();
    x = event->x()-centralWidget()->x();
    y = event->y()-centralWidget()->y();
    if(traceback){
        KOO* k; float d = 1e15;
        osm->select_cross(map->Y_to_lat(y),map->X_to_lon(x),c.mintype,
                          c.maxtype,&k,&d,osm->get_first_KOO());
        status1 = QString("%1Â°N %2 Â°E %3 m")
                          .arg(map->Y_to_lat(y),10,'f',6)
                          .arg(map->X_to_lon(x),10,'f',6)
                          .arg(map->XY_to_height(x,y),7,'f',1);
        trace_back(k);
    }
    else{
        if(event->buttons()==Qt::LeftButton){
            if(event->modifiers()==Qt::ControlModifier){
                // zoom box
                map->show_zoombox(x,xold,y,yold);
                status1 = QString("%1Â°N %2Â°E %3 m")
                                  .arg(map->Y_to_lat(y),10,'f',6)
                                  .arg(map->X_to_lon(x),10,'f',6)
                                  .arg(map->XY_to_height(x,y),7,'f',1);
            }
            else{
                // move map
                map->show_translated(x,xold,y,yold);
                status1 = "";
            }
        }
        else{
            status1 = QString("%1Â°N %2Â°E %3 m")
                              .arg(map->Y_to_lat(y),10,'f',6)
                              .arg(map->X_to_lon(x),10,'f',6)
                              .arg(map->XY_to_height(x,y),7,'f',1);
            MouseToTrack();
            Way* w = NULL;
            if(c.input == editdata){
                w = osm->select_Way(map->Y_to_lat(y),map->X_to_lon(x));
                if(w != NULL)
                    status2 = QString("way id: %1").arg(w->id);
                else
                    status2 = "";
            }
            update_map_MovObj(w);
        }
    }
    update_statusbar();
}
void MainWindow::wheelEvent(QWheelEvent * event ){
    x = event->x()-centralWidget()->x();
    y = event->y()-centralWidget()->y();
    int xmiddle = map->getwidth()/2;
    int ymiddle = map->getheight()/2;
    if (event->delta() < 0)
        zoom(2. ,1.*(x-xmiddle)/map->getwidth(),
             1.*(ymiddle-y)/map->getheight());
    else
        zoom(0.5,1.*(x-xmiddle)/map->getwidth(),
             1.*(ymiddle-y)/map->getheight());
}
void MainWindow::mouseDoubleClickEvent(QMouseEvent *event){
    // creates new crossroads
    double lon_dbcl = map->X_to_lon(event->x()-centralWidget()->x());
    double lat_dbcl = map->Y_to_lat(event->y()-centralWidget()->y());
    Way* wt = osm->select_Way(lat_dbcl,lon_dbcl);
    if(osm->insert_cross(wt,lat_dbcl,lon_dbcl))
        btp_modified = true;
}
void MainWindow::update_statusbar(){
    statusLeft->setText(status1);
    statusMiddle->setText(status2);
    ui->statusBar->update();//repaint();
}
void MainWindow::load_btp(){
    //QString filename = QFileDialog().getOpenFileName(this,"open BTP data","","BergTourenPlaner data (*.btp)");
    //if(!filename.isEmpty()){
    //    status2 = QString("Loading %1 ...").arg(filename);
    //    update_statusbar();
    //    load_btp(filename);
    //}
    QStringList filename = QFileDialog().getOpenFileNames(this,"open BTP data","","BergTourenPlaner data (*.btp)");
    if(!filename.isEmpty()){
        for(int i = 0; i < filename.length(); i++){
            status2 = QString("Loading %1 ...").arg(filename[i]);
            update_statusbar();
            load_btp(filename[i]);
        }
    }
}
void MainWindow::load_btp(QString filename){
    bool centermap = (osm->get_status()<3);
    osm->load(filename.toLocal8Bit().data());
    set_routingmode(c.input);
    if(centermap){
        osm->calc_brect();
        // if this is the first data loaded at this BTP instance
        c.MS.minlat = osm->getminlat();
        c.MS.maxlat = osm->getmaxlat();
        c.MS.minlon = osm->getminlon();
        c.MS.maxlon = osm->getmaxlon();
        if(c.MS.minlat >= c.MS.maxlat){
            c.MS.minlat = qMax(-90.,c.MS.maxlat-0.1);
            c.MS.maxlat = qMin( 90.,c.MS.minlat+0.1);
        }
        if(c.MS.minlon >= c.MS.maxlon){
            c.MS.minlon = qMax(-180.,c.MS.maxlon-0.1);
            c.MS.maxlon = qMin( 180.,c.MS.minlon+0.1);
        }
        map->set_borders(c.MS.minlat,c.MS.maxlat,c.MS.minlon,c.MS.maxlon);
        map->calc_borders();
    }
    update_map_raw();
    btp_modified = false;
}

void MainWindow::save_btp(){
    QString filename = QFileDialog().getSaveFileName(this,"save BTP data","","BergTourenPlaner data (*.btp)");
    if(!filename.isEmpty()){
        status2 = QString("Saving data within window to %1 ...").arg(filename);
        update_statusbar();
        save_btp(filename,map->getminlat(),map->getmaxlat(), map->getminlon(),
                 map->getmaxlon());
        set_routingmode(c.input);
        update_map_raw();
    }
}
void MainWindow::save_btp(QString filename, double minlat, double maxlat,
                          double minlon, double maxlon){
    osm->save(filename.toLocal8Bit().data(), minlat, maxlat, minlon, maxlon);
    btp_modified = false;
}
void MainWindow::read_osm(){
    QString filename = QFileDialog().getOpenFileName(this,"read OSM data","","OpenStreetMap data (*.osm)");
    if(!filename.isEmpty()){
        read_osm(filename);
        map->set_borders(c.MS.minlat,c.MS.maxlat,c.MS.minlon,c.MS.maxlon);
        map->calc_borders();
        update_map_raw();
        update_profil();
    }
}
void MainWindow::read_osm(QString filename){
    PA->setWindowTitle(filename);
    status2 = "Data is processed. This may last several minutes.";
    update_statusbar();
    osm->setfilename(filename.toLocal8Bit().data());
    osm->read_OSM();
    status2 = "Data read. Continue with generating relational data base.";
    update_statusbar();
    osm->get_KOO_Waysavl();
    osm->check_lines();
    osm->trim_points();
    status2 = "Data base ready. Processing OSM-Relationdata.";
    update_statusbar();
    osm->RelationstoWay(osm->router);
    osm->RelationstoFace(osm->woodr,osm->ln[Woodi]);
    osm->RelationstoFace(osm->waterr,osm->ln[Wateri]);
    status2 = "Relations processed. Loading heightdata server.";
    update_statusbar();
    osm->calc_brect();
    HeightData h2;
    switch(c.DEM_level){
        case 0: h2.set_SRTM3_folder(c.SRTM3folder); break;
        case 1: h2.set_SRTM1_folder(c.SRTM1folder); break;
        case 2: h2.set_SRTM066_folder(c.SRTM066folder); break;
        case 3: h2.set_SRTM018_folder(c.SRTM018folder); break;
    }
    h2.reset_t(osm->getminlat()-0.1,
               osm->getmaxlat()+0.1,
               osm->getminlon()-0.2,
               osm->getmaxlon()+0.2);
    status2 = "Heightdata ready. Ranking summits.";
    update_statusbar();
    osm->calc_peak_index_pro(&h2);
    osm->sort_peaks();
    status2 = "Summits ranked. Generating streets height data.";
    update_statusbar();
    WayHeight w(&h2,osm,qMax(0,3-c.DEM_level));
    osm->assign_traffic_restrictions();
    status2 = "OSM Processing has finished. First save data as *.btp an restart programm.";
    update_statusbar();
    set_routingmode(c.input);
    c.MS.minlat = osm->getminlat();
    c.MS.maxlat = osm->getmaxlat();
    c.MS.minlon = osm->getminlon();
    c.MS.maxlon = osm->getmaxlon();
}

void MainWindow::set_start_btp(){
    QString filename = QFileDialog().getOpenFileName(this,"select BTP file","","BergTourenPlaner data (*btp)");
    if(filename.isEmpty()){
        c.start_btp[0] = '\0';
        status2 = QString("Loading no btp data at programm start.");
    }
    else{
        strcpy(c.start_btp,filename.toLocal8Bit().data());
        status2 = QString("Loading %1 at program start.").arg(filename);
    }
    update_statusbar();
}
void MainWindow::profilinfo(double x){
    if(ct != NULL){
        double h;
        ct->extract_h(x,&h);
        KOO k;
        ct->extract_KOO(&k,x);
        int xpx = map->lon_to_x(k.lon);
        int ypx = map->lat_to_y(k.lat);
        status1 = QString("%1Â°N %2Â°E %3 m [%4 km %5 m]")
                          .arg(k.lat,10,'f',6)
                          .arg(k.lon,10,'f',6)
                          .arg(map->XY_to_height(xpx,ypx),7,'f',1)
                          .arg(x,7,'f',3)
                          .arg(h,6,'f',1);
        if(ct==lrt && PA->isready() && PA->isVisible()){
            QTime time = QTime(0,0,0,0).addSecs(PA->get_t(x));
            status1.append(QString("[%1 km/h  %2 W  %3 bpm %4]")
                           .arg(PA->get_v(x),0,'f',1)
                           .arg(PA->get_P(x),0,'f',0)
                           .arg(PA->get_bpm(x),0,'f',0)
                           .arg(time.toString()));
        }
        update_statusbar();
        xdot = map->lon_to_x(k.lon);
        ydot = map->lat_to_y(k.lat);
        dstate = waydot;
        update_map_MovObj(NULL);
    }

}
int MainWindow::trace_back(KOO* k){
    if(readytotrace){
        if(kl_i_to >= 0 || kl_i_from >= 0){
            //QMessageBox().exec();
            Track *tfrom,*tto, start(lrt),end(lrt);
            // first route wayfrom ct->get_KOO(kl_i_from) to new cross
            if(kl_i_from >= 0){
                /*ein Zwischenpunkt wird veraendert*/
                start.trim_right(kl_i_from);
                if(lrt->get_KOO(kl_i_from)->cd != NULL){
                    if(k->cd->s[0].from != NULL){
                        Neighbour** nl=NULL;
                        int nc;
                        r->extract_neighbourlist(&(lrt->get_KOO(kl_i_from)->cd->s[0]),
                                                &(k->cd->s[0]),
                                                &nl,&nc);
                        tfrom = new Track(nl,nc);
                    }
                    else
                        return 0;//tfrom = r->airline(hd,lrt->get_KOO(kl_i_from),k);
                }
                else
                    return 0;//tfrom = r->airline(hd,lrt->get_KOO(kl_i_from),k);;
            }
            else{
                /*Der Startpunkt wird veraendert*/
                start.delete_complete();
                tfrom = new Track();
            }
            // now route way from new cross to ct->get_KOO(kl_i_to)
            if( kl_i_to >= 0){
                /*ein Zwischenpunkt wird veraendert*/
                end.trim_left(kl_i_to);
                if(lrt->get_KOO(kl_i_to)->cd != NULL){
                    if(k->cd->s[1].from != NULL){
                        Neighbour** nl=NULL;
                        int nc;
                        r->extract_neighbourlist(&(lrt->get_KOO(kl_i_to)->cd->s[1]),&(k->cd->s[1]),
                                                &nl,&nc);
                        tto = new Track(nl,nc);
                        tto->invert();
                    }
                    else
                        return 0;//tto = r->airline(hd,k,lrt->get_KOO(kl_i_to));
                }
                else
                    return 0;//tto = r->airline(hd,k,lrt->get_KOO(kl_i_to));
            }
            else{
                /*Der Endpunktt wird veraendert*/
                end.delete_complete();
                tto = new Track();
            }
            start.add(tfrom);
            start.add(tto);
            //kl_i_to = start.get_KOOa_length()-1;
            start.add(&end);
            if(ct != lrt)
                delete ct;
            ct = new Track(&start);
            update_map_track();
            update_profil();
            return 1;
        }
        else{
            if(	k != knew && k->cd->s[STRONGindex].via != NULL){
                Neighbour** nl = NULL; int nc;
                if(ct != lrt)
                    delete ct;
                ct = new Track(lrt);
                r->extract_neighbourlist(NULL, &(k->cd->s[STRONGindex]),&nl,&nc);
                if(nc>1){
                    Track ttemp(&(nl[1]),nc-1);
                    ct->add(&ttemp);
                }
                delete nl;
                update_profil();
                update_map_track();
                return 1;
            }
            else
                return 0;

        }
    }
    else
        return 0;

}
void MainWindow::route_airline(){
    UR->add(ct);
    Track *airtrack = r->airline(hd,kold,knew);
    btp_modified = true;
    ct->add(airtrack);
    //delete airtrack;
    set_routingmode(c.input);
    lrt = ct;
    recalc_power();
    update_map_track();
    update_profil();
}
void MainWindow::route_short(){
    status2 = "Shortest track is routing ...";
    update_statusbar();
    if(!r->Dijkstra(kold,knew,c.maxtype,c.mintype,osm,0,r->get_d,
                    use_marked_ways,pf_short*apply_traffic_restrictions)){
        knew = kold;
        status2 = "Found no way!";
        update_statusbar();
        return;
    }
    Neighbour** nl=NULL;
    int nc;
    r->extract_neighbourlist(kold->cd->s,knew->cd->s,&nl,&nc);
    kold = NULL;
    Track tt(nl,nc);
    UR->add(ct);
    ct->add(&tt);
    set_routingmode(c.input);
    delete nl;
    lrt = ct;
    recalc_power();
    update_map_track();
    update_profil();
}
void MainWindow::route_salesman(){
    status2 = "Travelling-Salesman-Problem processing ...";
    update_statusbar();
    Track* result;
    QStringList fs = QFileDialog().getOpenFileNames(this,"Salesman customers","","BTP track (*.btr)");
    if(!fs.isEmpty()){
        bool* errors = new bool[fs.length()];
        Track **tracks = new Track*[fs.length()];
        bool all_tracks_OK = true;
        QString trackerror;
        for(int i = 0; i < fs.length(); i++){
            tracks[i] = new Track(fs[i].toLocal8Bit().data(),&get_KOO_helper,(void*)osm);
            if(!tracks[i]->notNULL()){
                trackerror.append(fs[i]).append(" could not be loaded into current data set.\n");
                all_tracks_OK = false;
            }
        }
        if(!all_tracks_OK){
            QMessageBox(QMessageBox::NoIcon,"Error",trackerror).exec();
            return;
        }
        if(!r->salesman(kold,knew,c.maxtype,c.mintype,osm,
                        tracks,fs.length(),&result,errors)){
            QString merr("Salesman could not be solved, because followings customers could not be reached:\n");
            for(int i = 0; i < fs.length(); i++)
                if(errors[i])
                    merr.append(fs[i]).append("\n");
            QMessageBox(QMessageBox::NoIcon,"Error",merr).exec();

        }
        else{
            UR->add(ct);
            ct->add(result);
            set_routingmode(c.input);
            lrt = ct;
            recalc_power();
            update_map_track();
            update_profil();
        }
    }
    set_routingmode(c.input);
}
void MainWindow::route_flat(){
    status2 = "Least vertical meter track is routing ...";
    update_statusbar();
    if(!r->Dijkstra(kold,knew,c.maxtype,c.mintype,osm,0,r->get_hm,
                    use_marked_ways,pf_flat*apply_traffic_restrictions)){
        knew = kold;
        status2 = "Found no way!";
        update_statusbar();
        return;
    }
    Neighbour** nl=NULL;
    int nc;
    r->extract_neighbourlist(kold->cd->s,knew->cd->s,&nl,&nc);
    kold = NULL;
    Track tt(nl,nc);
    UR->add(lrt);
    lrt->add(&tt);
    if(ct != lrt)
        delete ct;
    ct = lrt;
    recalc_power();
    update_map_track();;
    update_profil();
    set_routingmode(c.input);
    delete nl;
}
void MainWindow::route_time(){
    status2 = "routing for least time ...";
    update_statusbar();
    if(!r->Dijkstra(kold,knew,c.maxtype,c.mintype,osm,0,r->get_t,
                    use_marked_ways,pf_time*apply_traffic_restrictions)){
        knew = kold;
        status2 = "Found no way!";
        update_statusbar();
        return;
    }
    Neighbour** nl=NULL;
    int nc;
    r->extract_neighbourlist(kold->cd->s,knew->cd->s,&nl,&nc);
    kold = NULL;
    Track tt(nl,nc);
    UR->add(ct);
    ct->add(&tt);
    //set_routingmode(c.input);
    delete nl;
    lrt = ct;
    recalc_power();
    update_map_track();
    update_profil();
}
void MainWindow::route_STRONG(){
    STRONGsetting* s;
    bool hmonly = true;
    if(c.input == routemountain) s = &(c.mconfig);
    if(c.input == routeSTRONG)   s = &(c.sconfig);
    if(c.input == routeclimb){   s = &(c.cconfig); hmonly = false;}

    STRONGcalc* sc = new STRONGcalc(osm,kold,knew,c.maxtype,c.mintype,s,
                  &STRONGtracks,&sN,hmonly);
    connect(sc,SIGNAL(refresh_progress(int)),this,SLOT(STRONG_preview(int)));
    connect(sc,SIGNAL(finished(int)),this,SLOT(route_STRONG_finalize(int)));
    connect(this,SIGNAL(stop_STRONG()),sc,SLOT(stop_calculations()));
    STRONGstate = 1;
    sc->start();
}
void MainWindow::route_STRONG_finalize(int succes){
    if(succes){
        // STRONG algorithm has succesfully finsihed
        STRONGindex = sN-1;
        if(c.input == routemountain){
            // search for the track with most Hm/km
            double minQu = 0, Qut = -1;
            for(int i = 0; i < sN; i++){
                if(STRONGtracks[i] != NULL){
                    Qut = STRONGtracks[i]->get_height_meters()/STRONGtracks[i]->get_length();
                    if(Qut > minQu){
                        STRONGindex = i;
                        minQu = Qut;
                    }
                }
            }
            STRONGstate = 2;
            acceptSTRONG();
            kold = NULL;
        }
        else{
            readytotrace = 1;
            STRONGstate = 2;
            if(STRONGtracks[STRONGindex] == NULL)
                selectSTRONG(bw,1);
            else{
                status2 = QString("STRONG %1/%2, select with page up/down, ENTER to accept, 'm' to select any crossroad as end point")
                                  .arg(STRONGindex+1)
                                  .arg(sN);
                update_statusbar();
            }
            kold = NULL;
        }
    }
    else{
        status2 = "Found no way. Free Memory ...";
        update_statusbar();
        r->finish_STRONG();
        STRONGstate = readytotrace = 0;
        knew = kold;
        update_map_track();
        set_routingmode(c.input);
        status2 = "Found no way.";
        update_statusbar();
    }
}
void MainWindow::delete_STRONG_tracks(){
    if(STRONGtracks != NULL){
        for(int i = 0; i < sN; i++)
            if(STRONGtracks[i] != NULL)
                STRONGtracks[i]->~Track();
        free(STRONGtracks);
        STRONGtracks = NULL;
    }
}
void MainWindow::acceptSTRONG(){
    if(	   c.input == routeSTRONG
        || c.input == routemountain
        || c.input == routeclimb){
        if(STRONGstate == 2){
            status2 = "Free Memory ...";
            update_statusbar();
            r->finish_STRONG();				//allokierten Speicher freigeben
        }
        // add selected STRONG track to existing ct
        UR->add(lrt);
        if(lrt != ct)
            delete lrt;
        lrt = ct;
        recalc_power();
        update_profil();
        knew = ct->get_last_KOO();
        readytotrace = traceback = STRONGstate = 0;
        set_routingmode(c.input);
        update_map_track();
    }
}
void MainWindow::reset_track(){
    dstate = nonedot;					//es gibt keinen Punkt mehr zu zeigen
    if(c.input != editdata && !traceback){
        /* if routing then clear tracks anyway*/
        kold = NULL;
        knew = NULL;
        UR->add(lrt);
        lrt->delete_complete();
        ct->delete_complete();
    }
    switch(c.input){
        case routeclimb:
        case routeSTRONG:
            acceptSTRONG();
            set_routingmode(c.input);
            break;
        case routeshort:
        case routeflat:
        case routemountain:
            set_routingmode(c.input);
            break;
        case editdata:
            if(selected_way != NULL){
                osm->del_Way(selected_way);
                status2 = QString("Way %1 was deleted!").arg(selected_way->id);
                update_statusbar();
                selected_way = NULL;
                update_map_raw();
                btp_modified = true;
            }
            break;
        default: break;
    }
    recalc_power();
    update_profil();
    update_map_track();;
}
void MainWindow::set_routingmode(inputstate ip){
    if(STRONGstate == 2)
        acceptSTRONG();
    c.input = ip;
    selected_way = NULL;
    switch(c.input){
    case routeshort:
        status2  = QString("short; 'z' undo, 'y' redo, 'del' delete");
        break;
    case salesman:
        status2  = QString("saleman; 'z' undo, 'y' redo, 'del' delete");
        break;
    case routeflat:
        status2  = QString("flat; 'z' undo, 'y' redo, 'del' delete");
        break;
    case routetime:
        status2  = QString("min. time; 'z' undo, 'y' redo, 'del' delete");
        break;
    case routeclimb:
        if(c.cconfig.noSTRONGPlus)
            status2  = QString("[points: %1, step: %2, maxhmperkm: %3] routing STRONG, 'ESC' to cancel, 'z' undo, 'y' redo, 'del' to delete")
                                .arg(c.cconfig.hmmax)
                                .arg(c.cconfig.hmstep)
                                .arg(c.cconfig.hmperkm);
        else
            status2  = QString("[points: %1, step: %2, maxhmperkm: %3, dhmin: %4, minP: %5, downtoupmax: %6] routing STRONG with restrictions, ESC to cancel, z undo, r redo, entf to delete")
                                .arg(c.cconfig.hmmax)
                                .arg(c.cconfig.hmstep)
                                .arg(c.cconfig.hmperkm)
                                .arg(c.cconfig.dhmin)
                                .arg(c.cconfig.minP)
                                .arg(c.cconfig.downtoupmax);
        break;
    case routemountain:
        if(c.mconfig.noSTRONGPlus)
            status2  = QString("[HM: %1, step: %2, maxhmperkm: %3] routing STRONG, ESC to cancel, z undo, r redo, entf to delete")
                                .arg(c.mconfig.hmmax)
                                .arg(c.mconfig.hmstep)
                                .arg(c.mconfig.hmperkm);
        else
            status2  = QString("[HM: %1, step: %2, maxhmperkm: %3, dhmin: %4, minP: %5, downtoupmax: %6] routing STRONG with restrictions, ESC to cancel, z undo, r redo, entf to delete")
                                .arg(c.mconfig.hmmax)
                                .arg(c.mconfig.hmstep)
                                .arg(c.mconfig.hmperkm)
                                .arg(c.mconfig.dhmin)
                                .arg(c.mconfig.minP)
                                .arg(c.mconfig.downtoupmax);
        break;
    case routeSTRONG:
        if(c.sconfig.noSTRONGPlus)
            status2  = QString("[HM: %1, step: %2, maxhmperkm: %3] routing STRONG, ESC to cancel, z undo, r redo, entf to delete")
                                .arg(c.sconfig.hmmax)
                                .arg(c.sconfig.hmstep)
                                .arg(c.sconfig.hmperkm);
        else
            status2  = QString("[HM: %1, step: %2, maxhmperkm: %3, dhmin: %4, minP: %5, downtoupmax: %6] routing STRONG with restrictions, ESC to cancel, z undo, r redo, entf to delete")
                                .arg(c.sconfig.hmmax)
                                .arg(c.sconfig.hmstep)
                                .arg(c.sconfig.hmperkm)
                                .arg(c.sconfig.dhmin)
                                .arg(c.sconfig.minP)
                                .arg(c.sconfig.downtoupmax);
        break;
    case editdata:
        status2  = QString("select a way by mouse click, editing options: del .. delete, numbers 0-9 to change type");
        break;
    case selectlayer:
        if(SL != NULL){
            status2  = QString("STRONGlayer %1 of %2 is shown; page up/down to select").arg(SLc).arg(SLN);
            update_map_track();;
        }
        else
            status2  = QString("No STRONGlayer loaded");
        break;
    default: break;
    }
    if(use_marked_ways) status2.prepend("marked ways, ");
    if(apply_traffic_restrictions) status2.prepend("traffic hints, ");
    status2.prepend(QString("[%1 .. %2], ").arg(int(c.mintype)).arg(int(c.maxtype)));

    update_statusbar();
}
void MainWindow::delete_to_cross(int cc){
    UR->add(lrt);
    lrt->delete_cross(cc);
    if(ct != lrt)
        delete ct;
    ct = lrt;
    if(ct->notNULL())
        knew = ct->get_last_KOO();
    else
        knew = NULL;
    kold = NULL;
    recalc_power();
    update_profil();
    update_map_track();
}
void MainWindow::set_mintype(char mt){
    c.mintype = qMin(mt,char(MaxTrackType));
    set_routingmode(c.input);
}
void MainWindow::set_maxtype(char mt){
    if(c.input == editdata && selected_way != NULL){
        osm->change_Waytype(selected_way,mt);
        status2 = QString("way %1 changed, \n new typ: %2 ")
                    .arg(selected_way->id)
                    .arg(selected_way->type);
        selected_way = NULL;
        update_statusbar();
        update_map_raw();
        btp_modified = true;
    }
    else{
        c.maxtype = qMin(mt,char(MaxTrackType));
        set_routingmode(c.input);
    }
}
void MainWindow::undo(){
    if(lrt != ct)
        delete lrt;
    lrt = ct = UR->undo(ct);
    recalc_power();
    kold = NULL;
    knew = ct->get_last_KOO();
    update_profil();
    update_map_track();;
}
void MainWindow::redo(){
    if(lrt != ct){
        delete lrt;
        delete ct;
    }
    else
        delete ct;
    lrt = ct = UR->redo();
    recalc_power();
    kold = NULL;
    knew = ct->get_last_KOO();
    update_profil();
    update_map_track();
}
void MainWindow::selectSTRONG(readdirection rd, short steps){
    if((c.input == routeSTRONG || c.input == routeclimb) && readytotrace){
        if( rd == fw ){
            STRONGindex = min( sN-1, STRONGindex + steps);
            while(STRONGindex < sN-1 && STRONGtracks[STRONGindex] == NULL)
                STRONGindex++;
            if(STRONGtracks[STRONGindex] == NULL)
                selectSTRONG(bw,1);
        }
        else{
            STRONGindex = max( 0, STRONGindex - steps);
            while(STRONGindex > 0 && STRONGtracks[STRONGindex] == NULL)
                STRONGindex--;
            if(STRONGtracks[STRONGindex] == NULL)
                selectSTRONG(fw,1);
        }
        status2 = QString("STRONG %1/%2, select with page up/down, ENTER to accept, 'm' to select any crossroad as end point")
                          .arg(STRONGindex+1)
                          .arg(sN);
        update_statusbar();
        STRONG_preview(STRONGindex);
    }
    if(c.input == selectlayer && SL != NULL){
        if( rd == fw )
            SL = r->STRONGlayer_create(SL,qMin(sN-1,SLc + steps));
        else
            SL = r->STRONGlayer_create(SL,qMax(0   ,SLc - steps));
        status2 = QString("STRONGlayer %1 von %2 is shown. Select layer with page up/down").arg(SLc).arg(SLN);
        update_statusbar();
        update_map_raw();
    }
}
void MainWindow::MouseToTrack(){
    dstate = nonedot;
    double ddot;
    kdot = NULL;
    if( ct != NULL && ct->notNULL()){
        KOO ktt;
        switch(ct->next_cross(map->Y_to_lat(y),map->X_to_lon(x),&kdot,map->scale()*5)){
            case 1:
                dstate = crossdot;
                xdot = map->lon_to_x(kdot->lon);
                ydot = map->lat_to_y(kdot->lat);
                return;
            case 2:
                dstate = crossdotmarked;
                xdot = map->lon_to_x(kdot->lon);
                ydot = map->lat_to_y(kdot->lat);
                return;
        }
        // there is no cross of ct in reach, search absolut nearest point on ct
        if(ct->near_check(map->Y_to_lat(y),map->X_to_lon(x),
                          (map->getmaxlat()-map->getminlat())*0.1))
            // the track is close to the mouse point
            if(ct->next_d(map->Y_to_lat(y),map->X_to_lon(x),&ddot))
                // the neares point was found
                if(ct->extract_KOO(&ktt,ddot)){
                    // calc with the nearest point
                    xdot = map->lon_to_x(ktt.lon);
                    ydot = map->lat_to_y(ktt.lat);
                    dstate = waydot;
                    ui->profil->set_marker(ddot);
                    double h; ct->extract_h(ddot,&h);
                    status1.append(QString(" [%1 km %2 m]")
                                    .arg(ddot,7,'f',3)
                                    .arg(h,6,'f',1));
                    if(ct==lrt && PA->isready()&& PA->isVisible()){
                        int timei = PA->get_t(ddot);
                        QTime time = QTime(0,0,0,0).addSecs(timei);
                        status1.append(QString("[%1 km/h  %2 W  %3 bpm %4]")
                                       .arg(PA->get_v(ddot),0,'f',1)
                                       .arg(PA->get_P(ddot),0,'f',0)
                                       .arg(PA->get_bpm(ddot),0,'f',0)
                                       .arg(time.toString()));
                    }
                    return;
                }
    }
    ui->profil->set_marker(ui->profil->get_xmin());
}

void MainWindow::enter(){
    if(traceback)
        accept_ct();
    else{
        if(STRONGstate == 1){
            status2 = "STRONG calculation still running. ESC to quit.";
            update_statusbar();
        }
        else{
            if(	  c.input == routeSTRONG
                ||c.input == routeclimb
                ||c.input == routemountain){
                if(readytotrace)
                    acceptSTRONG();
                else{
                    kold = knew;
                    knew = NULL;
                    route_STRONG();
                }
            }
            if(	  c.input == routeflat && knew != NULL){
                status2 = "Flattest track with open end is routing ...";
                update_statusbar();
                r->Dijkstra(knew,NULL,c.maxtype,c.mintype,osm,0,r->get_hm,
                            use_marked_ways,pf_flat*apply_traffic_restrictions);
                readytotrace = 1; STRONGindex = 0; traceback = 1;
                kl_i_to = kl_i_from = -1;
                status2 = "Flattest tracks ready ...";
                update_statusbar();
            }
            if(	  c.input == routeshort && knew != NULL){
                status2 = "Shortest track with open end is routing ...";
                update_statusbar();
                r->Dijkstra(knew,NULL,c.maxtype,c.mintype,osm,0,r->get_d,
                            use_marked_ways,pf_short*apply_traffic_restrictions);
                readytotrace = 1; STRONGindex = 0; traceback = 1;
                kl_i_to = kl_i_from = -1;
                status2 = "Shortest track is ready ...";
                update_statusbar();
            }
            if(	  c.input == salesman){
                kold = knew;
                knew = NULL;
                route_salesman();
                knew = kold;
                kold = NULL;
            }
        }
    }
}
void MainWindow::accept_ct(){
    UR->add(lrt);
    if(lrt != ct)
        delete lrt;
    lrt = ct;
    recalc_power();
    update_profil();
    traceback = 0;
    readytotrace = 0;
    if(STRONGstate == 1)
        acceptSTRONG();
    knew = ct->get_last_KOO();
    kold = NULL;
    update_map_track();
    set_routingmode(c.input);
}
void MainWindow::toggle_preview(){
    if(readytotrace){
        kl_i_to = kl_i_from = -1;
        if(traceback == 0)
            traceback = 1;
        else
            traceback = 0;
    }
}
void MainWindow::STRONG_preview(int i){
    status2 = QString("STRONG calculation: %1/%2 steps done").arg(i).arg(sN);
    update_statusbar();
    if(STRONGtracks[i] != NULL){
        if(ct != lrt)
            delete ct;
        ct = new Track(lrt);
        ct->add(STRONGtracks[i]);
        update_map_track();
        update_profil();
    }
}
void MainWindow::STRONG_settings(){
    if( BTP3setups(&(c.sconfig),&(c.mconfig),&(c.cconfig)).exec())
        set_routingmode(c.input);
}
void MainWindow::create_STRONGlayer(){
    if(STRONGstate == 2){
        SL = r->STRONGlayer_create(SL,STRONGindex);
        c.drawSTRONGlayer = 1;
        update_map_raw();
    }
    else{
        status2 = "There is no finished STRONG calculation to operate upon.";
        update_statusbar();
    }
}
void MainWindow::save_STRONGlayer(){
    QString filename = QFileDialog().getSaveFileName(this,"save STRONGlayer","","BTP STRONGlayer (*.bsl)");
    if(SL != NULL && !filename.isEmpty()){
        r->STRONGlayer_save(filename.toLocal8Bit().data(),SL);
        status2 = QString("saved STRONGlayer as %1").arg(filename);
        update_statusbar();
    }
}
void MainWindow::load_STRONGlayer(){
    QString filename = QFileDialog().getOpenFileName(this,"load STRONGlayer","","BTP STRONGlayer (*.bsl)");
    if(!filename.isEmpty()){
        c.drawSTRONGlayer = 1;
        SL = r->STRONGlayer_load(filename.toLocal8Bit().data());
        update_map_raw();
    }
}
void MainWindow::toggle_STRONGlayer(){
    if(c.drawSTRONGlayer)
        c.drawSTRONGlayer = 0;
    else
        c.drawSTRONGlayer = 1;
    update_map_raw();
}
void MainWindow::AnalyseClimbs(){
    if(BTP3setups(&(c.CA)).exec()){
        QString oldstatus2 = status2;
        status2 = "Analysing climbs ...";
        update_statusbar();
        ClimbAnalyse CA(osm,c.mintype,c.maxtype,c.CA.minP,c.CA.minS,c.CA.maxdwnHM,
                       c.CA.minHM,hd);
            //QMessageBox(QMessageBox::NoIcon,"sdfg",QString("%1").arg(1)).exec();
        if(c.CA.list)	CA.create_list(c.CA.ProjectName,c.CA.ProjectFolder);
            //QMessageBox(QMessageBox::NoIcon,"sdfg",QString("%1").arg(2)).exec();
        if(c.CA.Climblayer){
            status2 = "Creating Climblayer ...";
            update_statusbar();
            c.drawClimblayer = 1;
            //QMessageBox(QMessageBox::NoIcon,"sdfg",QString("%1").arg(3)).exec();
            CL = CA.get_ClimbLayer();
            //QMessageBox(QMessageBox::NoIcon,"sdfg",QString("%1").arg(4)).exec();
            CA.save_ClimbLayer(c.CA.ProjectName,c.CA.ProjectFolder,CL);
            //QMessageBox(QMessageBox::NoIcon,"sdfg",QString("%1").arg(5)).exec();
            update_map_raw();
        }

        if(c.CA.map){
            status2 = "Generating map ...";
            update_statusbar();
            MAP mt(hd,osm);
            mt.settings(&(c.MS));
            double widthtoheight = (osm->getmaxlon()-osm->getminlon())
                    *cos(M_PI*(osm->getmaxlat()+osm->getminlat())/2./180.)
                    /(osm->getmaxlat()-osm->getminlat());
            int height = int(sqrt(c.CA.mapsize*1000000/widthtoheight));
            int width= int(height*widthtoheight);
            mt.resize(width,height);
            mt.set_borders(osm->getminlat(),osm->getmaxlat(),osm->getminlon(),osm->getmaxlon());
            mt.calc_borders();
            climblayer *clt = NULL;
            if(c.CA.Climblayer) clt = CL;
            mt.draw_map(NULL,clt,NULL,0);
            QString filename = QString(c.CA.ProjectFolder)
                                .append(c.CA.ProjectName).append(".png");
            mt.save_to_png(filename);
        }
        if(c.CA.html){
            status2 = "Generating html data ...";
            update_statusbar();
            CA.create_html_singlefile(c.CA.ProjectName,c.CA.ProjectFolder);
        }
            //QMessageBox(QMessageBox::NoIcon,"sdfg",QString("%1").arg(6)).exec();
        status2 = oldstatus2;
        update_statusbar();
    }
}
void MainWindow::load_Climblayer(){
    QString filename = QFileDialog().getOpenFileName(this,"load climblayer","","BTP climblayer (*.bbl)");
    if(!filename.isEmpty()){
        c.drawClimblayer = 1;
        ClimbAnalyse CA;
        CL = CA.load_ClimbLayer(filename.toLocal8Bit().data());
        update_map_raw();
    }
}
void MainWindow::toggle_Climblayer(){
    if(c.drawClimblayer)
        c.drawClimblayer = 0;
    else
        c.drawClimblayer = 1;
    update_map_raw();
}
void MainWindow::toggle_HikeBike(){
    if(c.MS.drawHikeBike)
        c.MS.drawHikeBike = 0;
    else
        c.MS.drawHikeBike = 1;
    update_map_raw();
}
void MainWindow::generate_Map(){
    ExtMapSettings ems;
    ems.maxlat = map->getmaxlat();
    ems.minlat = map->getminlat();
    ems.maxlon = map->getmaxlon();
    ems.minlon = map->getminlon();
    ems.drawCL = c.drawClimblayer;
    ems.drawSL = c.drawSTRONGlayer;
    ems.drawct = ct->notNULL();
    ems.mapsize = 4;
    if(BTP3setups(&ems).exec()){
        MAP mt(hd,osm);
        mt.settings(&(c.MS));
        double widthtoheight = (ems.maxlon-ems.minlon)
                                *cos(M_PI*(ems.maxlat+ems.minlat)/2./180.)
                                /(ems.maxlat-ems.minlat);
        int height = int(sqrt(ems.mapsize*1000000/widthtoheight));
        int width= int(height*widthtoheight);
        mt.resize(width,height);
        mt.set_borders(ems.minlat,ems.maxlat,ems.minlon,ems.maxlon);
        mt.calc_borders();
        STRONGlayer *slt = NULL;
        climblayer *clt = NULL;
        Track *ctt = NULL;
        if(ems.drawCL) clt = CL;
        if(ems.drawSL) slt = SL;
        if(ems.drawct) ctt = ct;
        mt.draw_map(slt,clt,ctt,0);

        QString filename = QFileDialog().getSaveFileName(this,"save Map","","portable network graphic (*.png)");
        if(!filename.isEmpty())
            mt.save_to_png(filename);
    }
}
void MainWindow::normalize_Hm(){
    osm->normalize_Hm(osm->get_first_KOO());
    status2 = "Routing Height data is normalized.";
    update_statusbar();
}
void MainWindow::invert_Hm(){
    osm->invert_Hm(osm->get_first_KOO());
    status2 = "Routing Height data is inverted.";
    update_statusbar();
}
void MainWindow::swap_Hm_d(){
    osm->swap_Hm_d(osm->get_first_KOO());
    status2 = "Height meters and distance swaped.";
    update_statusbar();
}

void MainWindow::save_profile(){
    QString filename = QFileDialog().getSaveFileName(this,"save Profil","","portable network graphic (*.png)");
    if(ct != NULL && !filename.isEmpty()){
        plot2D pt(ui->profil);
        pt.set_size(c.PS.width,c.PS.height);
        pt.refresh_pixmap();
        pt.save_to_png(filename.toLocal8Bit().data());
        status2 = QString("profil saved as %1").arg(filename);
        update_statusbar();
    }
}
void MainWindow::save_gpx(){
    QString filename = QFileDialog().getSaveFileName(this,"save track","","GPS exchange format (*.gpx)");
    if(ct != NULL && !filename.isEmpty()){
        ct->to_gpx(filename.toLocal8Bit().data());
        status2 = QString("track saved as %1").arg(filename);
        update_statusbar();
    }
}
void MainWindow::save_segment_gpx(){
    QString filename = QFileDialog().getSaveFileName(this,"save track","","GPS exchange format (*.gpx)");
    if(ct != NULL && !filename.isEmpty()){
        Track tt(ct);
        tt.trim_right(ui->profil->get_xmax());
        tt.trim_left(ui->profil->get_xmin());
        tt.to_gpx(filename.toLocal8Bit().data());
        status2 = QString("track saved as %1").arg(filename);
        update_statusbar();
    }
}
void MainWindow::profil_settings(){
    BTP3setups(&(c.PS)).exec();
    update_profil();
}
void MainWindow::map_settings(){
    BTP3setups(&(c.MS)).exec();
    update_map_raw();
}
void MainWindow::recalc_power(){
    if(PA->isVisible())
        PA->calc_track(lrt);
}
void MainWindow::toggle_poweranalysis(){
    if(PA->isVisible())
        PA->hide();
    else{
        PA->show();
        recalc_power();
        update_profil();
    }
}
void MainWindow::center_track(double d){
    if(ct->notNULL()){
        KOO k;
        ct->extract_KOO(&k,d);
        zoom(1,
             (k.lon-map->getmaxlon())/(map->getmaxlon()-map->getminlon())+0.5,
             (k.lat-map->getmaxlat())/(map->getmaxlat()-map->getminlat())+0.5);
    }
}
void MainWindow::zoom_profil(double dmin, double dmax){
    if(ct == lrt && PA->isready()){
        float hm = ct->get_height_meters(dmin,dmax);
        float d = dmax-dmin;
        ui->profil->set_labels(QString("%1 km  %2 Hm  %3 Hm/km  %4 km/h  %5 W  NP %6 W  %7 bpm  TRIMP %8")
                               .arg(d,0,'f',2)
                               .arg(hm,0,'f',0)
                               .arg(hm/d,0,'f',1)
                               .arg(PA->get_v(dmin,dmax),0,'f',1)
                               .arg(PA->get_P(dmin,dmax),0,'f',0)
                               .arg(PA->get_NP(dmin,dmax),0,'f',0)
                               .arg(PA->get_bpm(dmin,dmax),0,'f',0)
                               .arg(PA->get_TRIMP(dmin,dmax),0,'f',0),
                                "d [km]","h [m]");
    }
    ui->profil->refresh_pixmap();
}
void MainWindow::toggle_showpower(){
    if(c.plotpower)
        c.plotpower = 0;
    else
        c.plotpower = 1;
    update_profil();
}

void MainWindow::toggle_showspeed(){
    if(c.plotspeed)
        c.plotspeed = 0;
    else
        c.plotspeed = 1;
    update_profil();
}
void MainWindow::toggle_bpm(){
    if(c.plotbpm)
        c.plotbpm = 0;
    else
        c.plotbpm = 1;
    update_profil();
}
void MainWindow::analyse_gpx(QString filename){
    if(!filename.isEmpty()){
        gpx g(filename.toLatin1().data());
        double** data; long int length;
        data = g.get_complete(&length);
        if(length > 0){
            UR->add(ct);
            if(QMessageBox::Yes == QMessageBox::question(this,
                                               "Height data Handling",
                                               "Recalc height data?",
                                               QMessageBox::Yes|QMessageBox::No)){
                /*recalculate height data*/
                Neighbour *nb;
                WayHeight(hd,data[2],data[3],length,&nb);
                Track tt(&nb,1);
                for(int i = 0; i < length; i++)
                    data[1][i] = tt.get_h(i);
            }
            ct = new Track(data[0],data[1],data[2],data[3],length);
            PA->calc_track(ct,data[0],data[4],data[5],data[6],length);
            for(long i = 0; i < 5; i++)
                free(data[i]);
            free(data);

            ct->get_brect(&(c.MS.minlat),&(c.MS.maxlat),
                          &(c.MS.minlon),&(c.MS.maxlon));
            lrt = ct;
            map->set_borders(c.MS.minlat,c.MS.maxlat,c.MS.minlon,c.MS.maxlon);
            map->calc_borders();
            update_map_raw();
            update_profil();
        }
        else
            QMessageBox(QMessageBox::NoIcon,"Error",QString("Unable read data from %1").arg(filename)).exec();
    }
}
void MainWindow::analyse_gpx(){
    QString filename = QFileDialog().getOpenFileName(this,"analyse gpx","","GPS exchange format (*.gpx *fit)");
    analyse_gpx(filename);
}
void MainWindow::load_STRONGcalc(){
    QString filename = QFileDialog().getOpenFileName(this,"open STRONG calculation ","","STRONG calculation(*.sca)");
    //QString filename = "D:\\ClimbProject\\Osterzgebirge.sca";
    set_routingmode(routeSTRONG);
    STRONGcalc* sc = new STRONGcalc(osm,&sN,filename.toLocal8Bit().data(),
                                    &STRONGtracks);
    connect(sc,SIGNAL(finished(int)),this,SLOT(route_STRONG_finalize(int)));
    connect(sc,SIGNAL(status(QString)),this,SLOT(show_STRONG_status(QString)));

    STRONGstate = 1;
    sc->start();
}
void MainWindow::import_gpx(){
    QString filename = QFileDialog().getOpenFileName(this,"analyse gpx","","GPS exchange format (*.gpx)");
    gpx g(filename.toLatin1().data());
    double** data; long int length;
    data = g.get_complete(&length);
    if(length > 0){
        Routing rt(osm);
        ct = rt.KOO_to_map_to_track(data[2],data[3],length,c.maxtype,c.mintype,osm);
        PA->calc_track(ct,data[0],data[4],data[5],data[6],length);
        ct->get_brect(&(c.MS.minlat),&(c.MS.maxlat),
                      &(c.MS.minlon),&(c.MS.maxlon));
        lrt = ct;
        map->set_borders(c.MS.minlat,c.MS.maxlat,c.MS.minlon,c.MS.maxlon);
        map->calc_borders();
        update_map_raw();
        update_profil();
    }
}

void MainWindow::save_STRONGcalc(){
    if(STRONGstate == 2){
        QString filename = QFileDialog().getSaveFileName(this,"save STRONG calculation ","","STRONG calculation(*.sca)");
        //QString filename = "D:\\ClimbProject\\Osterzgebirge.sca";
        STRONGcalc* sc = new STRONGcalc(osm,sN,filename.toLocal8Bit().data(),
                                        &STRONGtracks);
        connect(sc,SIGNAL(finished(int)),this,SLOT(route_STRONG_finalize(int)));
        STRONGstate = 1;
        sc->start();
    }
    else{
        status2 = "There is no finished STRONG calculation to operate upon.";
        update_statusbar();
    }
}
void MainWindow::generate_tiles(){
    double maxlat0 = 52;
    double minlat0 = 36;
    double minlon0 = -11;
    double maxlon0 = 30;
    maxlon0 = -1.;
    /*maxlat0 = 60.0;
    minlat0 = 50.0;
    minlon0 = -11.0;
    malon0 = 2;*/


    int xmin, xmax, ymin, ymax;
    double step;
    maxlon0 += 180.;
    minlon0 += 180.;
    QString folderpath = "D:\\ClimbProject\\Tiles\\";
    Cmdl.clear();
    QString btppath = "D:\\ClimbProject\\btp-Data\\";
    for(int z = 9; z < 10; z++){
        step = 360. / pow(2.,z);
        xmin = int(floor(minlon0/step));
        xmax = int(floor(maxlon0/step));
        ymin = int(floor((180.-lattomercator(maxlat0))/step));
        ymax = int(floor((180.-lattomercator(minlat0))/step));
        for(int x = xmax; x >= xmin; x--)
        //for(int x = xmin; x <= xmax; x++)
            for(int y = ymin; y <= ymax; y++){
                webdatacmd w;
                w.x = x;
                w.z = z;
                w.y = y;
                w.dest = folderpath;
                w.src = btppath;
                w.mode = CreateTilesBTP;
                w.width = 256;
                w.height = 256;
                w.c = &c;
                w.osm = osm;
                Cmdl.append(w);
            }
    }
    /*for(int z = 5; z < 9; z++){
        step = 360. / pow(2.,z);
        xmin = int(floor(minlon0/step));
        xmax = int(floor(maxlon0/step));
        ymin = int(floor((180.-lattomercator(maxlat0))/step));
        ymax = int(floor((180.-lattomercator(minlat0))/step));
        for(int x = xmin; x <= xmax; x++)
            for(int y = ymin; y <= ymax; y++){
                webdatacmd w;
                w.x = x;
                w.z = z;
                w.y = y;
                w.dest = folderpath;
                w.mode = CreateTiles;
                w.width = 256;
                w.height = 256;
                w.c = &c;
                w.osm = osm;
                Cmdl.append(w);
            }
    }*/
    threadscount = 1;
    next_command();
}
void MainWindow::STRONG_europe(){
    double maxlat0 = 52;
    double minlat0 = 36;
    double minlon0 = -11;
    double maxlon0 = 30;

    /*maxlat0 = 60.0;
    minlat0 = 50.0;
    minlon0 = -11.0;
    maxlon0 = 2;*/

    int xmin, xmax, ymin, ymax;
    double step;
    maxlon0 += 180.;
    minlon0 += 180.;
    QString folderpath = "D:\\ClimbProject\\STRONGLayers\\";
    Cmdl.clear();
    QString btppath = "D:\\ClimbProject\\btp-Data\\";
    for(int z = 9; z < 10; z++){
        step = 360. / pow(2.,z);
        xmin = int(floor(minlon0/step));
        xmax = int(floor(maxlon0/step));
        ymin = int(floor((180.-lattomercator(maxlat0))/step));
        ymax = int(floor((180.-lattomercator(minlat0))/step));
        for(int x = xmin; x <= xmax; x++)
            for(int y = ymin; y <= ymax; y++){
                webdatacmd w;
                w.x = x;
                w.z = z;
                w.y = y;
                w.dest = folderpath;
                w.src = btppath;
                w.mode = CreateSTRONGLayers;
                w.width = 256;
                w.height = 256;
                w.c = &c;
                w.osm = osm;
                Cmdl.append(w);
            }
    }
    threadscount = -4;
    next_command();
}
void MainWindow::next_command(){
    threadscount--;
    for(int i = 0; i < 6-threadscount; i++ )
        if(Cmdl.length()>0){
            webdatacmd ele = Cmdl.takeLast();
            if(ele.mode == SummitCalc){
                SummitRanking* sr = new SummitRanking;
                QFuture<void> future = QtConcurrent::run(sr,
                                                   &SummitRanking::CalcSummits,
                                                   ele.y,
                                                   ele.x,
                                                   ele.src,
                                                   ele.dest);
                QFutureWatcher<void> m_futureWatcher;
                connect(&m_futureWatcher, SIGNAL(finished()),
                        this,SLOT(next_command()));
                m_futureWatcher.setFuture(future);
            }
            else{
                WebData* wd = new WebData(ele);
                connect(wd,SIGNAL(finished()),this,SLOT(next_command()));
                qRegisterMetaType<webdatacmd>("webdatacmd");
                connect(wd,SIGNAL(add(webdatacmd*)),this,SLOT(add_Cmd(webdatacmd*)));
                threadscount++;
                wd->start();
            }
        }
}
void MainWindow::add_Cmd(webdatacmd* w){
    Cmdl.append(*w);
}
void MainWindow::split_europe_pbf(){
    webdatacmd first;
    first.z = 0;
    first.x = 0;
    first.y = 0;
    first.mode = SplitEurope;

    Cmdl.append(first);
    threadscount = 1;
    next_command();
}
void MainWindow::correct_hgt(){
    QString foldername = QFileDialog::getExistingDirectory(this,"select SRTM3 data directory");
    if(!foldername.isEmpty()){
        QDir f(foldername,"*.hgt");
        HeightData HD;
        HD.set_SRTM3_folder(c.SRTM3folder);
        QString text;
        QStringList hgt = f.entryList();
        int correctedPoints;
        for(int i = 0; i < hgt.count();i++){
            correctedPoints = HD.correct_hgt(f.absoluteFilePath(hgt[i]).toLocal8Bit().data());
            if(correctedPoints > 0)
                text.append(QString("%1 corrected points in %2.\n").arg(correctedPoints).arg(hgt[i]));
        }
        if(text.isEmpty())
            text = "no hgt files corrected.";
        //HD.correct_hgt("C:\\Users\\User\\Desktop\\SRTM3\\N50E013.hgt");
        QMessageBox(QMessageBox::NoIcon,"hgt-correction",text).exec();
    }
}
void MainWindow::read_europe(){
    double maxlat0 = 72;
    double minlat0 = 36;
    double minlon0 = -11;
    double maxlon0 = 30;
    int z = 9;
    double step = 360. / pow(2.,z);
    int xmin = int(ceil((minlon0+180)/step));
    int xmax = int(floor((maxlon0+180)/step));
    int ymin = int(ceil((180.-lattomercator(maxlat0))/step));
    int ymax = int(floor((180.-lattomercator(minlat0))/step));
    QString folderpathsrc = "D:\\ClimbProject\\pbf-Data\\";
    QString folderpathdest = "D:\\ClimbProject\\btp-Data\\";
    for(int x = xmin; x < xmax; x++)
        for(int y = ymin; y < ymax; y++){
            webdatacmd w;
            w.dest = QString("%1%2-%3-%4.btp")
                      .arg(folderpathdest)
                      .arg(z)
                      .arg(x)
                      .arg(y);
            w.src = QString("%1%2-%3-%4.pbf")
                      .arg(folderpathsrc)
                      .arg(z)
                      .arg(x)
                      .arg(y);
            w.mode = ReadOSM;
            Cmdl.append(w);
        }
    threadscount = 1;
    next_command();
}
void MainWindow::CA_europe(){
    double maxlat0 = 72;
    double minlat0 = 36;
    double minlon0 = -11;
    double maxlon0 = 30;
    int z = 9;
    double step = 360. / pow(2.,z);
    int xmin = int(ceil((minlon0+180)/step));
    int xmax = int(floor((maxlon0+180)/step));
    int ymin = int(ceil((180.-lattomercator(maxlat0))/step));
    int ymax = int(floor((180.-lattomercator(minlat0))/step));
    QString folderpathsrc = "D:\\ClimbProject\\btp-Data\\";
    QString folderpathdest = "D:\\ClimbProject\\climb-data\\";
    for(int x = xmin; x < xmax; x++)
        for(int y = ymin; y < ymax; y++){
            webdatacmd w;
            w.z = 9;
            w.x = x;
            w.y = y;
            w.dest = QString("%1%2-%3")
                      .arg(folderpathdest)
                      .arg(x)
                      .arg(y);
            w.src = QString("%1%2-%3-%4.btp")
                      .arg(folderpathsrc)
                      .arg(z)
                      .arg(x)
                      .arg(y);
            w.mode = CreateHTML;
            Cmdl.append(w);
        }
    threadscount = 1;
    next_command();

}
void MainWindow::zoom14_collection(){
    double boxes[8][4] = {{10.15,51.33,11.55,51.95},//Harz
                          {9.44,49.85,17.8,51.5},//Rhoen-Jeseniky
                         {12.08,48.11,15.8,49.6},//BayWa
                         {6.5,46.95,9.4,48.92},//Aarau-Vosges-Schwarzwald
                         {1.8,43.9,45,46.2},//MassiveCentral
                         {18,48.55,21.3,49.9},//Slovensko
                         {6.9,48.8,9.44,51.6},// NRW
                         {4.4,48.9,8.35,50.8}};//Ardennen
    for(int b = 0; b < 8; b++){
        for(int z = 12; z < 15; z++){
            double step = 360. / pow(2.,z);
            int xmin = int(ceil((boxes[b][0]+180)/step));
            int xmax = int(floor((boxes[b][2]+180)/step));
            int ymin = int(ceil((180.-lattomercator(boxes[b][3]))/step));
            int ymax = int(floor((180.-lattomercator(boxes[b][1]))/step));
            for(int y = ymin; y < ymax; y++){
                QDir ydir(QString("D:\\ClimbProject\\ZoomedTiles")
                          .append(QString("\\%1\\%2")
                          .arg(z)
                          .arg(y)));
                if(!ydir.exists())
                    QDir (QString("D:\\ClimbProject\\ZoomedTiles")
                          .append(QString("\\%1")
                          .arg(z))).mkdir(ydir.dirName());
                for(int x = xmin; x < xmax; x++){
                    QFile f(QString("%1%2\\%3\\%4.png")
                           .arg("D:\\ClimbProject\\Tiles\\")
                           .arg(z)
                           .arg(y)
                           .arg(x));
                    f.copy(ydir.filePath(QString("%1.png").arg(x)));
                }
            }

        }
    }
}
void MainWindow::save_track_binary(){
    QString filename = QFileDialog().getSaveFileName(this,"save binary track","","BTP binary track(*.trk)");
    if(!filename.isEmpty())
        ct->to_binary_KOO(filename.toLocal8Bit().data());
}
void MainWindow::convert_binary_to_binaryPlus(){
    QStringList filename = QFileDialog().getOpenFileNames(this,"open BTP data","","BergTourenPlaner data (*.trk)");
    if(!filename.isEmpty()){
        for(int i = 0; i < filename.length(); i++){
            status2 = QString("Loading %1 ...").arg(filename[i]);
            update_statusbar();
            // read data
            FILE* f = fopen(filename[i].toLocal8Bit().data(),"rb");
            int kc = 0;
            fread(&kc,sizeof(kc),1,f);
            double* lat = new double[kc];
            double* lon = new double[kc];
            float buf;
            for(int i = 0; i < kc; i++){
                fread(&buf,sizeof(float),1,f);
                lat[i] = (double) buf;
                fread(&buf,sizeof(float),1,f);
                lon[i] = (double) buf;
            }
            fclose(f);
            // recalculate height data
            Neighbour *nb;
            WayHeight(hd,lat,lon,kc,&nb);
            Track t(&nb,1);
            QString newfilename(filename[i]);
            newfilename.chop(3);
            newfilename.append("src");
            t.to_binaryPlus(newfilename.toLocal8Bit().data());
        }
    }
}

void MainWindow::save_track_binaryPlus(){
    QString filename = QFileDialog().getSaveFileName(this,"save binaryPlus track","","BTP binaryPlus track (*.src)");
    if(!filename.isEmpty())
        ct->to_binaryPlus(filename.toLocal8Bit().data());
}
void MainWindow::save_btr(){
    QString filename = QFileDialog().getSaveFileName(this,"save BTP track","","BTP track(*.btr)");
    if(!filename.isEmpty())
        ct->to_btr(filename.toLocal8Bit().data());
}

void MainWindow::load_btr(){
    QString filename = QFileDialog().getOpenFileName(this,"load BTP track","","BTP track(*.btr)");
    if(!filename.isEmpty()){
        UR->add(ct);
        ct = new Track(filename.toLocal8Bit().data(),&get_KOO_helper,(void*)osm);
        if(ct->notNULL()){
            knew = ct->get_last_KOO();
            lrt = ct;
            recalc_power();
            ct->get_brect(&(c.MS.minlat),&(c.MS.maxlat),
                          &(c.MS.minlon),&(c.MS.maxlon));
            update_map_raw();
            update_profil();
        }
        else
            undo();
    }
}
KOO* get_KOO(qint64 id);

void MainWindow::summitranking_split(){
    SummitRanking("D:\\Summitranking\\allCountries.txt","D:\\Summitranking\\");
}
void MainWindow::summitranking_calc(){
    double ll[3][2]=
    {{35,74},
     {28,83},
     {30,79}};
    //for(int x = -178; x < 179; x++)
    //    for(int y = -79; y <80; y++){
    for(int x = 12; x < 19; x++)
       for(int y = 49; y < 51; y++){
            SummitRanking* sr = new SummitRanking();
            connect(sr,SIGNAL(log(QString,QString)),this,SLOT(log_calc(QString,QString)));
            QtConcurrent::run(sr,&SummitRanking::CalcSummits,
                              y, x, QString("D:\\dem3\\"), QString("D:\\Summitranking\\"));
        }
    /*for(int i = 0; i < 3786; i++){
        SummitRanking* sr = new SummitRanking();
        connect(sr,SIGNAL(log(QString,QString)),this,SLOT(log_calc(QString,QString)));
        QtConcurrent::run(sr,&SummitRanking::CalcSummits,
                          ll[i][0],ll[i][1], QString("D:\\dem3\\"), QString("D:\\Summitranking\\"));
    }*/
    //threadscount = 1;
    //next_command();
}
void MainWindow::log_calc(QString logfilename,QString message){
    FILE *f = fopen(logfilename.toLocal8Bit().data(),"a");
    if(f!= NULL){
        fprintf(f,"%s",message.toLocal8Bit().data());
        fclose(f);
    }
}
void MainWindow::summitranking_collect(){
    QDir dir("D:\\Summitranking\\4thcalc_standarddeviation","*.lst");
    QStringList hgt = dir.entryList();
    FILE* f = fopen("D:\\Summitranking\\4thcalc_standarddeviation\\WorldSummits.txt","w");
    char line[9999];
    int maxi = hgt.count();
    for(int i = 0; i < maxi; i++){
        FILE *ft = fopen(dir.absoluteFilePath(hgt[i]).toLocal8Bit().data(),"r");
        int stop = 0;
        bool OK[3];
        while(!feof(ft) && !stop){
            fgets(line,999,ft);
            QStringList sl = QString(line).split('\t');
            if(sl.length() > 5){
                double index = sl.at(0).toDouble(&(OK[0]));
                double index2 = sl.at(5).toDouble(&(OK[1]));
                double index3 = sl.at(5).toDouble(&(OK[2]));
                if(OK[0] && OK[1] && OK[2]){
                    if((100 < index)){
                        if(index2 > 1000 || index3 > 500)
                            fprintf(f,"%s",line);
                    }
                    else
                        stop = 1;
                }
            }
        }
        fclose(ft);
    }
    fclose(f);
}
void MainWindow::got_to_latlon(){
    QString text = QInputDialog::getText(this, tr("got to KOO"),
                                              tr("Enter lat lon string like: '47.34 -135.5'"));
    QStringList sl = text.remove('\n').split(' ');
    if(sl.length()<2)
        sl= text.split('\t');
    bool OK[2];
    if(sl.length()>1){
        double lat = sl[0].toDouble(&(OK[0]));
        double lon = sl[1].toDouble(&(OK[1]));
        if(OK[1] && OK[0]){
            zoom(1,
                 (lon-map->getmaxlon())/(map->getmaxlon()-map->getminlon())+0.5,
                 (lat-map->getmaxlat())/(map->getmaxlat()-map->getminlat())+0.5);
        }
    }
}
void MainWindow::list_sites_to_clipboard(){
    QApplication::clipboard()->setText(map->list_sites(ct));
}
void MainWindow::coordinate_to_clipbard(){
    QString cbs = QString("%1\t%2").arg(map->Y_to_lat(y)).arg(map->X_to_lon(x));
    QApplication::clipboard()->setText(cbs);
}
void MainWindow::network_length_to_clipboard(){
    double dtot = 0;
    double elevtot = 0;
    int Ntot = 0;
    int Ctot = 0;
    network_length_to_clipboard(osm->get_first_KOO(),&dtot,&elevtot, &Ctot, &Ntot);
    QString cbs = QString("%1 km length including back and forth (%3 segments)\n%2 km length one way counting\n")
                    .arg(dtot)
                    .arg(dtot/ 2.0)
                    .arg(Ntot);
    cbs.append(QString("%1 crossroads\n").arg(Ctot));
    cbs.append(QString("%1 m climbing back and forth").arg(elevtot));
    QMessageBox(QMessageBox::NoIcon,"Total Network Statistics",cbs).exec();
}
void MainWindow::network_length_to_clipboard(KOO* k, double* d, double* elev, int *C, int *N){
    if(k != NULL){
        if(k->cd != NULL){
            *C += 1;
            Neighbour* n = k->cd->neighbours;
            while(n != NULL){
                if(n->way->type >= c.mintype && n->way->type <= c.maxtype){
                    *d += n->d;
                    *elev += n->hm;
                    *N += 1;
                }
                n = n->next;
            }
        }
        network_length_to_clipboard(k->l,d,elev,C,N);
        network_length_to_clipboard(k->r,d,elev,C,N);
    }
}
void MainWindow::climb_analysis_current_segment(){
    // get track data
    Track tt(ct);
    tt.trim_right(ui->profil->get_xmax());
    tt.trim_left(ui->profil->get_xmin());
    double ** d = tt.get_d_h_array();
    int tc = tt.get_d_h_length();
    /*
    // helper data
    int* rank = importance(tc,d[0],1000,d[1],1);
    int* rr = new int[tc];              // rank reference
    for(int i = 0; i < tc; i++) rr[i] = -1;
    for(int i = 0; i < tc; i++)
        if(rank[i]>0 && rank[i] < tc) rr[rank[i]] = i;
    // create start population of climbs
    climb* c = new climb[tc+1];
    for(int i = 1; i < tc; i++){
        c[i].prev = &(c[i-1]);
        c[i].next = &(c[i+1]);
        c[i].init((d[0][i]-d[0][i-1])*1000.,
                   d[1][i]-d[1][i-1]);
    }
    c[1].prev = c[tc-1].next = NULL;
    // condense climbs
    for(int i = tc-1; i>= 0; i--){
        if(rr[i] > -1){
            climb* merged = new climb(&(c[rr[i]]),c[rr[i]].next);
            if(i<100)
                brake = i;
            if(merged != NULL && c[rr[i]].next != NULL){
                if(merged->next != NULL) merged->next->prev = c[rr[i]].next;
                if(merged->prev != NULL) merged->prev->next = c[rr[i]].next;
                c[rr[i]].next->clone(merged);
            }
        }
        else
            brake = i;
    }
    // show result
    if(rr[1] > -1){
        QString result = QString("%1 climbs found with %2 P total")
                            .arg(c[rr[1]].branches)
                            .arg(c[rr[1]].P);
        QMessageBox(QMessageBox::NoIcon,"Error",result).exec();
    }
    // free memory
    delete rank;
    delete rr;
    */
    // straight forward solution
    ////////////////////////////
    // helper data
    double* Pmax = new double[tc+1];
    double* Pmax_d = new double[tc+1];
    double* Pmax_dstart = new double[tc+1];
    double* hmdwn = new double[tc];
    double Pt = hmdwn[0] = 0;
    double Pmaxt = Pmax[tc] = 0;
    for(int i = 0; i < tc; i++){
        Pmax[i] = Pmax_d[i] = 0;
        d[0][i] *= 1000;
    }
    // scan complete
    int i0 = 0;
    for(int i = 1; i < tc; i++){
        hmdwn[i] = hmdwn[i-1] + qMax(0.,d[1][i-1] - d[1][i]);
        // search for new nearest point;
        while(hmdwn[i]-hmdwn[i0] + d[1][i] - d[1][i0] > 70 && i0 < i-1) i0++;
        // scan backwards
        int j = i0;
        Pmaxt = 0;
        while(j >= 0 && (hmdwn[i]-hmdwn[i0])/(d[1][i] - d[1][i0]) < 0.1){
            Pt = climb_P(d[0][i] - d[0][j],d[1][i] - d[1][j],hmdwn[i]-hmdwn[j]);
            if(Pt > Pmaxt){
                Pmaxt = Pt;
                if(Pmaxt > Pmax[j])
                    for(int k = j; k <= i; k++){
                        Pmax[k] = Pt;
                        Pmax_d[k] = d[0][i] - d[0][j];
                        Pmax_dstart[k] = d[0][j];
                    }
            }
            j--;
        }
    }
    // read out
    double Ptotal = 0;
    int cc = 0;
    QString result;
    for(int i = 1; i < tc; i++){
        if(Pmax[i] >= Pmax[i-1] && Pmax[i] > Pmax[i+1]){
            Ptotal += Pmax[i];
            cc++;
            result.append(QString("km %5: %1 P %2 Hm %3 \% %4 km %6 W %7 bpm %8 min\n")
                          .arg(Pmax[i],10,'f',1,' ')
                          .arg(sqrt(Pmax[i]*Pmax_d[i]),10,'f',1,' ')
                          .arg(sqrt(Pmax[i]*Pmax_d[i]) / Pmax_d[i] * 100,10,'f',1,' ')
                          .arg(Pmax_d[i]/1000.,10,'f',2,' ')
                          .arg(Pmax_dstart[i]/1000.,4,'f',0,' ')
                          .arg(PA->get_P  (ui->profil->get_xmin()+Pmax_dstart[i]/1000.,
                                           ui->profil->get_xmin()+(Pmax_dstart[i]+Pmax_d[i])/1000.),8,'f',0,' ')
                          .arg(PA->get_bpm(ui->profil->get_xmin()+Pmax_dstart[i]/1000.,
                                           ui->profil->get_xmin()+(Pmax_dstart[i]+Pmax_d[i])/1000.),8,'f',0,' ')
                          .arg((PA->get_t(ui->profil->get_xmin()+(Pmax_dstart[i]+Pmax_d[i])/1000.)
                               -PA->get_t(ui->profil->get_xmin()+ Pmax_dstart[i]           /1000.))/60.,8,'f',2,' ')
                          );
        }
    }
    result.prepend(QString("%1 climbs found with %2 P total\n")
                        .arg(cc)
                        .arg(Ptotal,0,'f',1));
    QMessageBox(QMessageBox::NoIcon,"Segments Climb analysis",result).exec();

}
void MainWindow::training_diary(){
    QStringList filename = QFileDialog().getOpenFileNames(this,"training diary entry from fit files","","Flexible and Interoperable Data Transfer (*.fit)");
    int dmin = 99999999999, dmax = 0;
    if(!filename.isEmpty()){
        gpx** g = new gpx*[filename.length()];
        PowerAnalysis** pa = new PowerAnalysis*[filename.length()];
        for(int i = 0; i < filename.length(); i++){
            status2 = QString("analysing %1 ...").arg(filename[i]);
            update_statusbar();
            g[i] = new gpx(filename[i].toLocal8Bit().data());
            double** data; long int length;
            data = g[i]->get_complete(&length);
            dmin = qMin(dmin,int(data[4][0] / (24*3600)));
            dmax = qMax(dmax,int(data[4][0] / (24*3600)));
            Track* tt = new Track(data[0],data[1],data[2],data[3],length);
            pa[i] = new PowerAnalysis(&(c.PA));
            pa[i]->calc_track(tt,data[0],data[4],data[5],data[6],length);
        }
        // helper data
        double* d[7];                       // 1: cycling, 2: skiing, 3: running, 4: bpm, 5: NP, 6: Trimp
        double* t[7];
        for(int i = 1; i < 7; i++){
            d[i] = new double[dmax-dmin+1];
            t[i] = new double[dmax-dmin+1];
            for(int k = 0 ; k < dmax-dmin+1; k++)
                d[i][k] = t[i][k] = 0;
        }
        // collect data
        for(int i = 0; i < filename.length(); i++){
            int iact = g[i]->get_typ();
            int iday = pa[i]->unixtime  / (24*3600) - dmin;
            d[iact][iday] += pa[i]->get_d();
            t[iact][iday] += pa[i]->get_t();
            d[4]   [iday] += pa[i]->get_bpm()*pa[i]->get_t();
            t[4]   [iday] += pa[i]->get_t();
            d[6]   [iday] += pa[i]->get_TRIMP();
            t[6]   [iday] += pa[i]->get_t();
            if(iact == 1){
                d[5][iday]    += pa[i]->get_NP()*pa[i]->get_t();
                t[5][iday]    += pa[i]->get_t();
            }
        }
        // print data
        QString cbs;
        for(int k = 0 ; k < dmax-dmin+1; k++){
            if(t[4][k] > 0)  cbs.append(QString("%1\t").arg(d[4][k]/t[4][k],0,'f',0));
            else                cbs.append("\t");
            if(d[1][k] > 0)  cbs.append(QString("%1\t").arg(d[1][k]/1000.,0,'f',1));
            else                cbs.append("\t");
            if(t[1][k] > 0)  cbs.append(QString("%1\t").arg(d[1][k]/t[1][k]*3.6,0,'f',1));
            else                cbs.append("\t");
            cbs.append("\t");
            if(t[5][k] > 0)  cbs.append(QString("%1\t").arg(d[5][k]/t[5][k],0,'f',0));
            else                cbs.append("\t");
            if(d[6][k] > 0)  cbs.append(QString("%1\t").arg(d[6][k],0,'f',0));
            else                cbs.append("\t");
            cbs.append("\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t");
            if(d[3][k] > 0)  cbs.append(QString("%1\t").arg(d[3][k]/1000.,0,'f',1));
            else                cbs.append("\t");
            if(d[2][k] > 0)  cbs.append(QString("%1\t").arg(d[2][k]/1000.,0,'f',1));
            else                cbs.append("\t");
            cbs.append("\t\t\t");
            double tfeet = (t[2][k] + t[3][k])/60.;
            if(tfeet > 0)       cbs.append(QString("%1\t").arg(tfeet,0,'f',1));
            else                cbs.append("\t");
            cbs.append("\n");
        }
        QApplication::clipboard()->setText(cbs);
    }
}
