#ifndef TERRAINHELPER_H
#define TERRAINHELPER_H
#include <QList>
#include "HeightData.h"
#include "MathExt.h"

typedef struct pxinfo{
    float d,h,lat,lon;
}pxinfo;

class dh{
public:
    dh(double d,double h);
    double d,y;
    bool operator<(const dh o2)const;
};
class xyz{
public:
    xyz();
    void fromEukl(double x, double y, double z);
    xyz(double lat, double lon, double h);
    xyz(xyz* a);
    void substract(xyz a);
    void add(xyz a);
    xyz difference(xyz a);
    double lat();
    double lon();
    double h();
    void set_length(double l);
    void sphere(double *lat,double *lon, double *h);
    double nrm();
    void normalize();
    xyz normalized();
    double x,y,z;
    double operator*(const xyz o2)const;
    xyz operator*(const double o2)const;
    xyz operator+(const xyz o2)const;
    xyz cross(const xyz o2)const;
    void refract(xyz g, double dndx);
    xyz refracted(xyz g, double dndx);
};

class px: public xyz{
public:
    px(xyz a);
    QColor c;
    float d;
    float X,Y,Z;
    int hlon,hlat;
    void project(xyz* nh, xyz*nv, xyz*nz);
    void zoom(double f);
    bool operator<(const px o)const;
};
#endif // TERRAINHELPER_H
